var ga_storage;

// For POST calls
var param = function (obj) {
    var query = '', name, value, fullSubName, subName, subValue, innerObj, i;

    for (name in obj) {
        value = obj[name];

        if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
                subValue = value[i];
                fullSubName = name + '[' + i + ']';
                innerObj = {};
                innerObj[fullSubName] = subValue;
                query += param(innerObj) + '&';
            }
        }
        else if (value instanceof Object) {
            for (subName in value) {
                subValue = value[subName];
                fullSubName = name + '[' + subName + ']';
                innerObj = {};
                innerObj[fullSubName] = subValue;
                query += param(innerObj) + '&';
            }
        }
        else if (value !== undefined && value !== null)
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
    }

    return query.length ? query.substr(0, query.length - 1) : query;
};

function DeepLinkHandler(data) {
    if (data) {
        window.localStorage['laundry_branch'] = JSON.stringify(data);
        window.location = '#app/branch';
    }
    else {
        console.log('No data found');
    }
}

angular.module('getlaundry', [
    'ionic',
    'ngCordova',
    'pascalprecht.translate',
    'ionicLazyLoad',
    'ion-sticky',
    'getlaundry.app_controller',
    'getlaundry.customers_controller',
    'getlaundry.providers_controller',
    'jett.ionic.filter.bar',
    // Services
    'getlaundry.app_services',
    'getlaundry.order_services',
    'getlaundry.customer_services',
    //Directives
    'getlaundry.common_directives',
    'ionic.closePopup',
    'intlpnIonic',
    'angular.filter'
])

        .constant('APP_VERSION', '2.0.5')
        //.constant('API_URL', 'http://localhost:5901/marketplace_live/api/v3/')
        .constant('API_URL', 'http://104.199.212.135/api/v3/')

        .run(function ($ionicPlatform, $ionicSideMenuDelegate, $rootScope, $timeout, $cordovaSplashscreen, Auth, Message, FConnection, Intercom) {

            // Disable back button
            $ionicPlatform.registerBackButtonAction(function (event) {
                if ($ionicSideMenuDelegate.isOpen()) {

                    // Add animate css class to out popup container
                    $timeout(function () {
                        var popupElements = document.getElementsByClassName("popup-container");
                        if (popupElements.length) {
                            popupElement = angular.element(popupElements[0]);
                            popupElement.addClass('animated');
                            popupElement.addClass('bounceInDown');
                        }
                    }, 1);

                    var title = 'Exit Getlaundry';
                    var message = 'Are you sure you want to exit Getlaundry?';

                    Message.confirm(title, message).then(function (res) {
                        if (res === true || res == 2) {
                            navigator.app.exitApp();
                        }
                    });
                }
                else {
                    $ionicSideMenuDelegate.toggleLeft();
                }
            }, 200);

            $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromParams, toParams) {
                $rootScope.logged = Auth.isLogged();
            });

            $ionicPlatform.ready(function () {

                FConnection.listen();

                // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                // for form inputs)
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                    cordova.plugins.Keyboard.disableScroll(true);

                }
                if (window.StatusBar) {
                    // org.apache.cordova.statusbar required
                    StatusBar.styleDefault();
                }

                setTimeout(function () {
                    $cordovaSplashscreen.hide();

                    if (typeof intercom != 'undefined') {
                        setTimeout(function () {
                            if (!Auth.isLogged()) {
                                intercom.registerUnidentifiedUser();
                            }
                            else {
                                Intercom.init();
                            }
                        }, 2500);
                    }
                }, 100);

                $ionicPlatform.on("resume", function (event) {
                    if (typeof Branch != 'undefined') {
                        Branch.initSession();
                    }
                });

                if (typeof Branch != 'undefined') {
                    Branch.initSession();
                }
            });
        })

        .config(function ($stateProvider, $urlRouterProvider, $compileProvider, $translateProvider, $ionicConfigProvider, $httpProvider) {

            if (!ionic.Platform.isIOS()) {
                $ionicConfigProvider.scrolling.jsScrolling(false);
            }

            $translateProvider.useSanitizeValueStrategy(null);

            $translateProvider.preferredLanguage("en");
            $translateProvider.fallbackLanguage("en");

            $translateProvider.useStaticFilesLoader({
                prefix: 'languages/',
                suffix: '.json' //file extension
            });

            $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|file|blob):|data:image\//);
            $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|file|sms|mailto|tel):/);

            $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
            $httpProvider.interceptors.push('MyHttpIntercept');
            $httpProvider.defaults.transformRequest = [function (data) {
                    return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
                }];

            $ionicConfigProvider.backButton.text('').icon('ion-ios-arrow-left');
            $ionicConfigProvider.views.swipeBackEnabled(false);

            $stateProvider

                    .state('app', {
                        url: '/app',
                        abstract: true,
                        templateUrl: 'templates/menu.html',
                        controller: 'AppCtrl'
                    })

                    .state('app.map', {
                        cache: false,
                        url: '/map',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/map.html',
                                controller: 'MapCtrl'
                            }
                        }
                    })

                    .state('app.providers', {
                        url: '/providers',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/providers.html',
                                controller: 'ProvidersCtrl'
                            }
                        }
                    })

                    .state('app.provider_details', {
                        cache: false,
                        url: '/provider_details/:id_provider',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/provider_details.html',
                                controller: 'ProviderDetailsCtrl'
                            }
                        }
                    })

                    .state('app.schedule', {
                        cache: false,
                        url: '/schedule',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/schedule.html',
                                controller: 'ScheduleCtrl'
                            }
                        }
                    })

                    .state('app.set_address', {
                        cache: false,
                        url: '/set_address',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/set_address.html',
                                controller: 'SetAddressCtrl'
                            }
                        }
                    })

                    .state('app.set_schedule', {
                        cache: false,
                        url: '/set_schedule',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/set_schedule.html',
                                controller: 'SetScheduleCtrl'
                            }
                        }
                    })

                    .state('app.set_instructions', {
                        url: '/set_instructions',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/set_instructions.html',
                                controller: 'SetInstructionsCtrl'
                            }
                        }
                    })

                    .state('app.success', {
                        url: '/success/:id_order',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/success.html',
                                controller: 'SuccessCtrl'
                            }
                        }
                    })

                    .state('app.checkout', {
                        cache: false,
                        url: '/checkout',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/checkout.html',
                                controller: 'CheckoutCtrl'
                            }
                        }
                    })

                    .state('app.account', {
                        cache: false,
                        url: '/account',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/account.html',
                                controller: 'AccountCtrl'
                            }
                        }
                    })

                    .state('app.cards', {
                        cache: false,
                        url: '/cards',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/cards.html',
                                controller: 'CardsCtrl'
                            }
                        }
                    })

                    .state('app.add_payment', {
                        cache: false,
                        url: '/add_payment',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/add_payment.html',
                                controller: 'AddPaymentCtrl'
                            }
                        }
                    })

                    .state('app.preferences', {
                        url: '/preferences',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/preferences.html',
                                controller: 'PreferencesCtrl'
                            }
                        }
                    })

                    .state('app.addresses', {
                        cache: false,
                        url: '/addresses',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/addresses.html',
                                controller: 'AddressesCtrl'
                            }
                        }
                    })

                    .state('app.history', {
                        cache: false,
                        url: '/history',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/history.html',
                                controller: 'HistoryCtrl'
                            }
                        }
                    })

                    .state('app.view_order', {
                        cache: false,
                        url: '/view_order/:id_order',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/view_order.html',
                                controller: 'OrderCtrl'
                            }
                        }
                    })

                    .state('app.free_laundry', {
                        cache: false,
                        url: '/free_laundry',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/free_laundry.html',
                                controller: 'FreeLaundryCtrl'
                            }
                        }
                    })

                    .state('app.support', {
                        cache: false,
                        url: '/support',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/support.html',
                                controller: 'SupportCtrl'
                            }
                        }
                    })

                    .state('app.tips', {
                        url: '/tips/:from_menu',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/tips.html',
                                controller: 'TipsCtrl'
                            }
                        }
                    })

                    .state('app.faq', {
                        url: '/faq',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/faq.html',
                                controller: 'FaqCtrl'
                            }
                        }
                    })

                    .state('app.terms', {
                        url: '/terms',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/terms.html',
                                controller: 'TermsCtrl'
                            }
                        }
                    })

                    .state('app.internet_error', {
                        url: '/internet_error',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/internet_error.html',
                                controller: 'InternetCtrl'
                            }
                        }
                    })

                    .state('app.business', {
                        url: '/business',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/business.html',
                                controller: 'BusinessCtrl'
                            }
                        }
                    })

                    .state('app.languages', {
                        url: '/languages',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/languages.html',
                                controller: 'LanguagesCtrl'
                            }
                        }
                    })

                    .state('app.branch', {
                        cache: false,
                        url: '/branch',
                        views: {
                            'menuContent': {
                                controller: 'BranchCtrl'
                            }
                        }
                    });

            if (window.localStorage['laundry_viewed_tips'] == 1) {
                $urlRouterProvider.otherwise('/app/map');
            }
            else {
                $urlRouterProvider.otherwise('/app/tips/2');
            }
        });