angular.module('getlaundry.app_controller', [])

        .controller('AppCtrl', function ($scope, $rootScope, Message, $ionicHistory, Push, Loading, Badge, Language, Rate, Intercom, $state, $ionicSideMenuDelegate, FOrder, $translate, $cordovaFacebook, $ionicModal, FCustomer, APP_VERSION, Session, Auth) {

            $scope.app_version = APP_VERSION;
            $rootScope.logged = Auth.isLogged();
            $scope.actions = [
                {id: 0, title: $translate.instant('signin')},
                {id: 1, title: $translate.instant('signup')},
                {id: 2, title: $translate.instant('forgot')}
            ];
            $scope.active_option = $scope.actions[0];
            $scope.default_img = 'img/default.jpg';
            $scope.default_user = 'img/default_user.png';
            $scope.sending = false;

            Session.unset('push_asked');
            Session.unset('redirect');
            Session.unset('previous_view');

            // Check previous version
            var version = Session.get('app_version');
            if (typeof version == 'undefined' || version == null || version != APP_VERSION) {
                Session.set('app_version', APP_VERSION);

                /*
                 $rootScope.logged = false;
                 Session.unset('categories');
                 Session.unset('country_code');
                 Session.unset('country_email');
                 Session.unset('country_languages');
                 Session.unset('country_link');
                 Session.unset('tips');
                 Session.unset('prefix');
                 Session.unset('order_type');
                 Session.unset('phone');
                 Session.unset('minimum_amount');
                 Auth.logout();
                 */
            }

            $scope.new_order = function () {
                FOrder.deleteProviders();
                FOrder.deleteProvider();
                FOrder.resetOrder();
                FOrder.resetCart();
                Session.unset('previous_view');
                Session.unset('editing_order');
                Session.unset('from_map');
                $scope.adding_address = false;
                $scope.previous_view = '';
            };

            $scope.new_order();

            // Set variables if logged and new version
            if (Auth.isLogged()) {
                $scope.customer = FCustomer.getCustomer();

                // Register GCM
                if ($scope.customer.id_gcm) {
                    Push.register();
                }

                if ($scope.customer.pref_keep_config) {
                    Loading.show('Loading your last configuration...');
                    FCustomer.load_config()
                            .success(function (response) {
                                if (response.success) {
                                    Session.set('formatted_address', angular.toJson(response.formatted));
                                    Session.set('id_address', response.id_address);
                                    Session.set('loaded_details', angular.toJson(response.address_details));

                                    Session.set('providers', angular.toJson(response.providers));

                                    $state.go('app.provider_details', {id_provider: response.id_provider});
                                }

                                Loading.hide();
                            })
                            .error(function () {
                                Loading.hide();
                            });
                }

                Language.setLanguage($scope.customer.language);
            }
            else {
                var language = Session.get('language');

                if (language != null && language != '') {
                    Language.setLanguage(Session.get('language'));
                }
                else {
                    Session.set('language', 'en');
                }
            }

            // Form data for the login modal
            $scope.loginData = {};

            // Create the login modal that we will use later
            $ionicModal.fromTemplateUrl('templates/login.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.modal = modal;

                console.log($ionicHistory.currentStateName());

                if (!Auth.isLogged() && Session.get('viewed_tips') == 1 && $ionicHistory.currentStateName() != 'app.tips') {
                    $scope.modal.show();
                }
            });

            // Triggered in the login modal to close it
            $scope.closeLogin = function () {
                $scope.modal.hide();
            };

            // Open the login modal
            $scope.login = function () {
                $scope.action = 1;
                $scope.modal.show();
            };

            $scope.doLogin = function () {
                $scope.sending = true;
                Loading.show($translate.instant('checking_credentials'));

                FCustomer.login($scope.loginData)
                        .success(function (response) {

                            $scope.sending = false;
                            Loading.hide();

                            if (response.success) {
                                Session.set('access', 'OK');
                                Session.set('api_signature', response.customer.api_signature);

                                $scope.customer = response.customer;
                                FCustomer.saveCustomer($scope.customer);

                                Intercom.init();
                                Language.setLanguage(response.customer.language);

                                $rootScope.logged = true;
                                $scope.closeLogin();
                                $scope.loginData = {};

                                if ($ionicSideMenuDelegate.isOpen()) {
                                    $ionicSideMenuDelegate.toggleLeft();
                                }

                                if (Session.get('redirect') == 'checkout') {
                                    Session.unset('redirect');
                                    $state.go('app.checkout');
                                }
                                else if (Session.get('redirect') == 'cash') {
                                    Session.unset('redirect');
                                    Message.show($translate.instant('can_submit'));
                                }
                                else {
                                    var provider = FOrder.getProvider();
                                    if (response.redirect && (typeof provider == 'undefined' || provider == null)) {
                                        $scope.new_order();

                                        Session.set('formatted_address', angular.toJson(response.formatted));
                                        Session.set('id_address', response.id_address);
                                        Session.set('loaded_details', angular.toJson(response.address_details));

                                        Session.set('providers', angular.toJson(response.providers));

                                        $state.go('app.provider_details', {id_provider: response.id_provider});
                                    }
                                    else {
                                        $state.go('app.map');
                                    }
                                }
                            }
                            else {
                                Message.show(response.error);
                            }
                        });
            };

            // Facebook Login
            $scope.fbLogin = function () {
                var fb_token = '';

                Loading.show($translate.instant('loading'));

                FCustomer.create_fb_token()
                        .success(function (response) {

                            if (response.success) {
                                fb_token = response.token;
                                Session.set('fb_token', fb_token);

                                $cordovaFacebook.getLoginStatus()
                                        .then(function (success) {
                                            if (success.status === 'connected') {
                                                $cordovaFacebook.api("me?fields=id,email,name", ["public_profile"])
                                                        .then(function (user) {

                                                            var data = {
                                                                'email': user.email,
                                                                'token': fb_token
                                                            };

                                                            FCustomer.check_fb_token(data)
                                                                    .success(function (response) {

                                                                        if (response.success) {
                                                                            Session.set('access', 'OK');
                                                                            Session.set('api_signature', response.customer.api_signature);

                                                                            $scope.customer = response.customer;
                                                                            FCustomer.saveCustomer($scope.customer);

                                                                            Intercom.init();
                                                                            Language.setLanguage(response.customer.language);

                                                                            $rootScope.logged = true;
                                                                            $scope.closeLogin();
                                                                            $scope.loginData = {};

                                                                            if ($ionicSideMenuDelegate.isOpen()) {
                                                                                $ionicSideMenuDelegate.toggleLeft();
                                                                            }

                                                                            var save_addr = false;
                                                                            if (Session.get('redirect') == 'checkout') {
                                                                                save_addr = true;
                                                                                Session.unset('redirect');
                                                                                $state.go('app.checkout');
                                                                            }
                                                                            else if (Session.get('redirect') == 'cash') {
                                                                                save_addr = true;
                                                                                Session.unset('redirect');
                                                                                Message.show($translate.instant('can_submit'));
                                                                            }
                                                                            else {
                                                                                var provider = FOrder.getProvider();
                                                                                if (response.redirect && (typeof provider == 'undefined' || provider == null)) {
                                                                                    $scope.new_order();

                                                                                    Session.set('formatted_address', angular.toJson(response.formatted));
                                                                                    Session.set('id_address', response.id_address);
                                                                                    Session.set('loaded_details', angular.toJson(response.address_details));

                                                                                    Session.set('providers', angular.toJson(response.providers));

                                                                                    $state.go('app.provider_details', {id_provider: response.id_provider});
                                                                                }
                                                                                else {
                                                                                    $state.go('app.map');
                                                                                }
                                                                            }

                                                                            if (save_addr) {
                                                                                var location = angular.fromJson(Session.get('location'));
                                                                                FCustomer.add_address(location)
                                                                                        .success(function (response) {
                                                                                            var order = FOrder.getOrder();
                                                                                            order.id_address = response.id_address;

                                                                                            FOrder.saveOrder(order);
                                                                                        });
                                                                            }
                                                                        }

                                                                        Loading.hide();
                                                                    })
                                                                    .error(function () {
                                                                        Loading.hide();
                                                                    });

                                                        }, function (error) {
                                                            Loading.hide();
                                                        });
                                            }
                                            else {
                                                $cordovaFacebook.login(["public_profile", "email", "user_friends"])
                                                        .then(function (success) {

                                                            $cordovaFacebook.api("me?fields=id,email,name", ["public_profile"])
                                                                    .then(function (user) {

                                                                        Loading.show($translate.instant('loading'));

                                                                        var data = {
                                                                            'email': user.email,
                                                                            'token': fb_token
                                                                        };

                                                                        FCustomer.check_fb_token(data)
                                                                                .success(function (response) {

                                                                                    if (response.success) {
                                                                                        Session.set('access', 'OK');
                                                                                        Session.set('api_signature', response.customer.api_signature);

                                                                                        $scope.customer = response.customer;
                                                                                        FCustomer.saveCustomer($scope.customer);

                                                                                        Intercom.init();
                                                                                        Language.setLanguage(response.customer.language);

                                                                                        $rootScope.logged = true;
                                                                                        $scope.closeLogin();
                                                                                        $scope.loginData = {};

                                                                                        if ($ionicSideMenuDelegate.isOpen()) {
                                                                                            $ionicSideMenuDelegate.toggleLeft();
                                                                                        }

                                                                                        if (Session.get('redirect') == 'checkout') {
                                                                                            Session.unset('redirect');
                                                                                            $state.go('app.checkout');
                                                                                        }
                                                                                        else if (Session.get('redirect') == 'cash') {
                                                                                            Session.unset('redirect');
                                                                                            Message.show($translate.instant('can_submit'));
                                                                                        }
                                                                                        else {
                                                                                            var provider = FOrder.getProvider();
                                                                                            if (response.redirect && (typeof provider == 'undefined' || provider == null)) {
                                                                                                $scope.new_order();

                                                                                                Session.set('formatted_address', angular.toJson(response.formatted));
                                                                                                Session.set('id_address', response.id_address);
                                                                                                Session.set('loaded_details', angular.toJson(response.address_details));

                                                                                                Session.set('providers', angular.toJson(response.providers));

                                                                                                $state.go('app.provider_details', {id_provider: response.id_provider});
                                                                                            }
                                                                                            else {
                                                                                                $state.go('app.map');
                                                                                            }
                                                                                        }
                                                                                    }

                                                                                    Loading.hide();
                                                                                })
                                                                                .error(function () {
                                                                                    Loading.hide();
                                                                                });

                                                                    }, function (error) {
                                                                        Loading.hide();
                                                                    });
                                                        }, function (error) {
                                                            Loading.hide();
                                                        });
                                            }
                                        }, function (error) {
                                            Loading.hide();
                                        });
                            }
                            else {
                                Loading.hide();
                                Message.show(response.error);
                            }
                        })
                        .error(function () {
                            Loading.hide();
                            Message.show($translate.instant('internet'));
                        });
            };

            $scope.signUp = function () {

                $scope.sending = true;
                Loading.show($translate.instant('creating_account'));
                FCustomer.signup($scope.loginData)
                        .success(function (response) {

                            $scope.sending = false;
                            Loading.hide();

                            if (response.success) {
                                $scope.customer = response.customer;
                                FCustomer.saveCustomer($scope.customer);

                                Intercom.init();

                                Session.set('access', 'OK');
                                $rootScope.logged = true;
                                $scope.closeLogin();
                                $scope.loginData = {};

                                if ($ionicSideMenuDelegate.isOpen()) {
                                    $ionicSideMenuDelegate.toggleLeft();
                                }

                                var save_addr = false;
                                if (Session.get('redirect') == 'checkout') {
                                    save_addr = true;
                                    Session.unset('redirect');
                                    $state.go('app.checkout');
                                }
                                else if (Session.get('redirect') == 'cash') {
                                    save_addr = true;
                                    Session.unset('redirect');
                                    Message.show($translate.instant('can_submit'));
                                }
                                else {
                                    $state.go('app.map');
                                }

                                if (save_addr) {
                                    var location = angular.fromJson(Session.get('location'));
                                    FCustomer.add_address(location)
                                            .success(function (response) {
                                                var order = FOrder.getOrder();
                                                order.id_address = response.id_address;

                                                FOrder.saveOrder(order);
                                            });
                                }
                            }
                            else {
                                Message.show(response.error);
                            }
                        })
                        .error(function () {
                            $scope.sending = false;
                            Message.show($translate.instant('an_error'));
                        });
            };

            $scope.doRecover = function () {

                $scope.sending = true;
                Loading.show($translate.instant('loading'));

                FCustomer.recover($scope.loginData.email)
                        .success(function (response) {

                            $scope.sending = false;
                            Loading.hide();

                            if (response.success) {
                                Message.show($translate.instant('sent_email'));
                            }
                            else {
                                Message.show(response.error);
                            }
                        });
            };

            $scope.logout = function () {
                var title = $translate.instant('log_out');
                var message = $translate.instant('sure_logout');

                Message.confirm(title, message).then(function (res) {
                    if (res === true || res == 2) {
                        Auth.logout();
                        $rootScope.logged = false;

                        if ($ionicSideMenuDelegate.isOpen()) {
                            $ionicSideMenuDelegate.toggleLeft();
                        }
                        $state.go('app.map');
                    }
                });
            };

            $scope.change_action = function (option) {
                $scope.active_option = $scope.actions[option];
            };

            $scope.rate_us = function () {
                if (typeof AppRate != 'undefined') {
                    Rate.rateApp();
                }
            };

            // Init Analytis
            var cont = 0;
            function _waitForAnalytics() {
                if (typeof ga_storage !== 'undefined') {
                    try
                    {
                        ga_storage._setAccount('UA-11717954-8');
                        ga_storage._trackPageview('app.html', 'App Started');
                    }
                    catch (e)
                    {
                        console.log(e.message);
                    }
                }
                else {
                    setTimeout(function () {
                        cont++;
                        if (cont < 20) {
                            _waitForAnalytics();
                        }
                    }, 250);
                }
            }
            _waitForAnalytics();


			setTimeout(function() {
				if (typeof Badge != 'undefined') {
					Badge.clear();
				}
			}, 2000);
            
        })

        .controller('MapCtrl', function ($scope, Session, $cordovaSplashscreen, $rootScope, Auth, $state, $ionicModal, $translate, Loading, FOrder, FConnection, Message, FCustomer, IonicClosePopupService, $timeout, $ionicPopup) {

            $scope.moving = false;
            $scope.placing = false;
            $scope.finding = false;
            $scope.selected_location = {};
            $scope.request = {};
            $scope.address = {};
            $scope.show_list = false;
            $scope.addresses = [];
            $scope.loading_address = false;
            $rootScope.logged = Auth.isLogged();
            $scope.data1 = {
                selected_country: 'AE',
                areas: []
            };
            var map;

            $scope.$on("$ionicView.enter", function (event, data) {

                $cordovaSplashscreen.hide();

                if (FConnection.isOffline()) {
                    $state.go('app.internet_error');
                    return false;
                }

                $scope.previous_view = Session.get('previous_view');
                $scope.adding_address = $scope.previous_view == 'schedule' || $scope.previous_view == 'account';

                Session.unset('previous_view');

                if (!$scope.adding_address) {
                    Session.unset('loaded_details');
                    Session.unset('loaded_address');
                    Session.unset('id_address');
                    $scope.check_is_ordering();
                }

                if (map != null) {
                    google.maps.event.trigger(map, 'resize');
                    map.setZoom(map.getZoom());
                }

                try
                {
                    ga_storage._trackPageview('map.html', 'Map');
                }
                catch (e)
                {
                    console.log(e.message);
                }

            });

            var orderPopup;
            $scope.check_is_ordering = function () {
                var provider = FOrder.getProvider();
                if (typeof provider != 'undefined' && provider != null) {
                    // Add animate css class to out popup container
                    $timeout(function () {
                        var popupElements = document.getElementsByClassName("popup-container");
                        if (popupElements.length) {
                            $scope.popupElement = angular.element(popupElements[0]);
                            $scope.popupElement.addClass('animated');
                            $scope.popupElement.addClass('bounceInDown');
                        }
                    }, 1);

                    orderPopup = $ionicPopup.show({templateUrl: 'templates/ordering.html',
                        title: $translate.instant('order_in_progress'),
                        scope: $scope
                    });

                    $scope.keep_order = function () {
                        orderPopup.close();
                        $state.go('app.schedule');
                    };
                }
                else {
                    Session.unset('editing_order');
                }
            };

            $scope.$on("$ionicView.beforeLeave", function (event, data) {
                if (typeof orderPopup != 'undefined') {
                    orderPopup.close();
                }
            });

            $scope.geocodeLatLng = function () {
                var position = $scope.map.getCenter();

                var lat = position.lat();
                var lng = position.lng();

                var latlng = {lat: lat, lng: lng};

                $scope.geocoder.geocode({'location': latlng}, function (results, status) {

                    if (status === google.maps.GeocoderStatus.OK) {
                        if (results[1]) {
                            $scope.search = results[1].formatted_address;

                            var temp = results[1].address_components;

                            var res = temp[temp.length - 1];
                            if (res.types[0] == 'country') {
                                $scope.data1.selected_country = temp[temp.length - 1].short_name;
                            }
                            else {
                                $scope.data1.selected_country = temp[temp.length - 2].short_name;
                            }

                            $scope.$apply();

                            $scope.selected_location.lat_lng = latlng;
                            $scope.selected_location.formatted_address = $scope.search;
                        }
                        else {
                            console.log('No results found');
                            $scope.search = '';
                        }
                    }
                    else {
                        console.log('Geocoder failed due to: ' + status);
                        $scope.search = '';
                    }

                    $scope.placing = false;

                    $scope.$apply();
                });
            };

            function initialize() {

                if (typeof google == 'undefined' || google.maps.places == 'undefined') {
                    FConnection.reload_modules();
                    return false;
                }

                var styles = [
                    {
                        featureType: "poi",
                        stylers: [
                            {visibility: "off"}
                        ]
                    }
                ];

                var mapOptions = {
                    center: {lat: 25.2048, lng: 55.2708},
                    zoom: 16,
                    disableDefaultUI: true, // DISABLE MAP TYPE
                    scrollwheel: false,
                    styles: styles,
                    clickableIcons: false
                };
                map = new google.maps.Map(document.getElementById('map'), mapOptions);
                var geocoder = new google.maps.Geocoder;

                $scope.map = map;
                $scope.geocoder = geocoder;

                var input = document.getElementById('pac-input');

                var autocomplete = new google.maps.places.Autocomplete(input);
                //var types = ['address'];
                //autocomplete.setTypes(types);
                autocomplete.bindTo('bounds', map);


                map.controls[google.maps.ControlPosition.TOP_LEFT].push(input);

                $scope.do_find_me = function () {
                    $rootScope.logged = Auth.isLogged();
                    $scope.finding = true;
                    //Loading.show('Finding your location...');

                    // Get customer location
                    navigator.geolocation.getCurrentPosition(function (geoposition) {
                        $scope.finding = false;
                        var coords = geoposition.coords;
                        var position = {lng: coords.longitude, lat: coords.latitude};

                        $scope.map.setCenter(position);
                        $scope.map.setZoom(16);

                        Loading.hide();

                        Session.unset('loaded_address');

                        $scope.geocodeLatLng();

                    }, function (error) {
                        $scope.finding = false;
                        console.log(error.message);
                        Loading.hide();

                        if (ionic.Platform.isIOS()) {
                            Message.show('To use geolocation service please activate this from your phone settings');
                        }
                    });

                    try
                    {
                        ga_storage._trackPageview('findme.html', 'Find me');
                    }
                    catch (e)
                    {
                        console.log(e.message);
                    }
                };

                $scope.find_me = function () {

                    if ($scope.finding) {
                        return false;
                    }

                    if (typeof cordova != 'undefined') {
                        cordova.plugins.diagnostic.isLocationAvailable(function (available) {
                            if (available) {
                                $scope.do_find_me();
                            }
                            else {
                                if (ionic.Platform.isAndroid()) {
                                    var title = 'Enable Geolocation';
                                    var message = 'Geolocation service is disabled, do you want to enable this now?';

                                    Message.confirm(title, message).then(function (res) {
                                        if (res === true || res == 2) {
                                            cordova.plugins.diagnostic.switchToLocationSettings();
                                        }
                                    });

                                    return false;
                                }
                                else if (ionic.Platform.isIOS()) {
                                    $scope.do_find_me();
                                }
                                else {
                                    Message.show('To use geolocation service please activate this from your phone settings');
                                    return false;
                                }
                            }
                        }, function (error) {
                            return false;
                        });
                    }
                    else {
                        $scope.do_find_me();
                    }
                };

                // Search for geolocation if enable
                if (typeof cordova != 'undefined') {
                    cordova.plugins.diagnostic.isLocationAvailable(function (available) {
                        if (available) {
                            $scope.find_me();
                        }
                        else {
                            $scope.geocodeLatLng();

                            if (ionic.Platform.isAndroid()) {
                                var title = 'Enable Geolocation';
                                var message = 'Geolocation service is disabled, do you want to fix this now?';

                                Message.confirm(title, message).then(function (res) {
                                    if (res === true || res == 2) {
                                        cordova.plugins.diagnostic.switchToLocationSettings();
                                    }
                                });
                            }
                            else if (ionic.Platform.isIOS()) {
                                $scope.do_find_me();
                            }
                            else {
                                Message.show('To use geolocation service please activate this from your phone settings');
                            }
                        }
                    }, function (error) {
                        $scope.geocodeLatLng();
                    });
                }
                else {
                    $scope.find_me();
                }

                map.addListener('dragstart', function () {
                    $scope.drag_start();
                });

                map.addListener('dragend', function () {
                    $scope.drag_end();
                });

                google.maps.event.addListener(autocomplete, 'place_changed', function () {

                    var place = autocomplete.getPlace();
                    if (!place.geometry) {
                        return;
                    }

                    if (place.geometry.viewport) {
                        map.fitBounds(place.geometry.viewport);
                    }
                    else {
                        map.setCenter(place.geometry.location);
                    }

                    $scope.geocodeLatLng();
                });
            }

            initialize();

            $scope.disableTap = function () {
                var container = document.getElementsByClassName('pac-container');
                angular.element(container).attr('data-tap-disabled', 'true');
                var backdrop = document.getElementsByClassName('backdrop');
                angular.element(backdrop).attr('data-tap-disabled', 'true');
                angular.element(container).on("click", function () {
                    document.getElementById('pac-input').blur();
                });
            };

            $scope.drag_start = function () {
                $scope.moving = true;
                $scope.placing = false;
                $rootScope.logged = Auth.isLogged();

                Session.unset('loaded_details');
                Session.unset('loaded_address');
                Session.unset('id_address');

                $scope.$apply();
            };

            $scope.drag_end = function () {
                $scope.moving = false;
                $scope.placing = true;

                $scope.geocodeLatLng();

                $scope.$apply();
            };

            $scope.add_customer_address = function (redirect) {

                FCustomer.add_address($scope.selected_location)
                        .success(function (response) {

                            $scope.placing = false;
                            if (response.success) {
                                if (typeof response.id_address != 'undefined') {
                                    Session.set('id_address', response.id_address);
                                }

                                $state.go(redirect);
                            }
                            else {
                                if (response.errorCode == 'NO_PROVIDERS') {
                                    $scope.show_empty();
                                }
                                else {
                                    Message.show(response.error);
                                }
                            }
                        });
            };

            $scope.place_order = function (id_area) {

                var from_map = true;

                if (typeof id_area != 'undefined' && id_area != null) {
                    from_map = false;
                }

                if ($scope.placing) {
                    return false;
                }

                $scope.placing = true;

                if ($scope.previous_view == 'account') // From Account
                {
                    $scope.add_customer_address('app.addresses');
                }
                else if ($scope.previous_view == 'schedule') // From schedule
                {
                    if (Auth.isLogged()) {
                        $scope.add_customer_address('app.set_address');
                    }
                    else {
                        $scope.provider = FOrder.getProvider();

                        FOrder.check_provider_location($scope.provider.id_provider, $scope.selected_location)
                                .success(function (response) {

                                    $scope.placing = false;
                                    if (response.success) {
                                        Session.set('formatted_address', response.formatted_address);
                                        Session.set('location', angular.toJson($scope.selected_location));

                                        $state.go('app.schedule');
                                    }
                                    else {
                                        if (response.errorCode == 'NO_COVER') {
                                            $scope.show_no_cover();
                                        }
                                        else {
                                            Message.show(response.error);
                                        }
                                    }
                                });
                    }
                }
                else {
                    if (Auth.isLogged() && Session.get('loaded_address') > 0) {
                        $scope.selected_location.id_address = Session.get('loaded_address');
                    }

                    var to_send = $scope.selected_location;

                    if (!from_map) {
                        to_send = {
                            manual: true,
                            id_area: id_area
                        };

                        Session.set('loc_from_area', id_area);

                        try
                        {
                            ga_storage._trackPageview('manual_destination.html', 'Manual Destination');
                        }
                        catch (e)
                        {
                            console.log(e.message);
                        }
                    }
                    else {
                        Session.unset('loc_from_area');
                    }

                    FOrder.get_providers_by_location(to_send)
                            .success(function (response) {

                                $scope.placing = false;

                                if (!from_map) {
                                    $scope.closeAreas();
                                }

                                if (response.success) {
                                    Session.set('formatted_address', response.formatted_address);
                                    Session.set('location', angular.toJson($scope.selected_location));

                                    if (typeof response.id_address != 'undefined') {
                                        Session.set('id_address', response.id_address);
                                        Session.set('loaded_details', angular.toJson(response.address_details));
                                    }

                                    Session.set('providers', angular.toJson(response.providers));

                                    if (response.go_schedule) {
                                        Session.set('formatted_address', angular.toJson(response.formatted_address));

                                        if (Auth.isLogged()) {
                                            Session.set('id_address', response.id_address);
                                            Session.set('loaded_details', angular.toJson(response.address_details));
                                        }
                                        else {
                                            Session.set('location', angular.toJson($scope.selected_location));
                                        }

                                        Session.set('provider', angular.toJson(response.provider));
                                        Session.set('from_map', 1);
                                        $state.go('app.schedule');
                                    }
                                    else {
                                        if (response.providers.length == 1) {
                                            var id_provider = response.providers[0].id_provider;
                                            $state.go('app.provider_details', {id_provider: id_provider});
                                        }
                                        else {
                                            $state.go('app.providers');
                                        }
                                    }
                                }
                                else {
                                    if (response.errorCode == 'NO_PROVIDERS') {
                                        $scope.show_empty();
                                    }
                                    else {
                                        Message.show(response.error);
                                    }
                                }
                            })
                            .error(function () {
                                $scope.placing = false;

                                if (!from_map) {
                                    $scope.closeAreas();
                                }
                            });
                }
            };

            var myPopup;
            $scope.show_empty = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                myPopup = $ionicPopup.show({
                    templateUrl: 'templates/no_providers.html',
                    title: $translate.instant('start_delivering'),
                    scope: $scope
                });
                IonicClosePopupService.register(myPopup);

                try
                {
                    ga_storage._trackPageview('no_providers.html', 'No Providers');
                }
                catch (e)
                {
                    console.log(e.message);
                }
            };

            $scope.close_empty = function () {
                myPopup.close();
            };

            var requestPopup;
            $scope.show_request = function () {

                myPopup.close();

                if (Auth.isLogged()) {
                    $scope.submit_request();
                }
                else {
                    setTimeout(function () {
                        // Add animate css class to out popup container
                        $timeout(function () {
                            var popupElements = document.getElementsByClassName("popup-container");
                            if (popupElements.length) {
                                $scope.popupElement = angular.element(popupElements[0]);
                                $scope.popupElement.addClass('animated');
                                $scope.popupElement.addClass('bounceInDown');
                            }
                        }, 1);

                        requestPopup = $ionicPopup.show({templateUrl: 'templates/request.html',
                            title: $translate.instant('no_providers2'),
                            scope: $scope
                        });
                        IonicClosePopupService.register(requestPopup);
                    }, 500);
                }
            };

            $scope.close_request = function () {
                requestPopup.close();
            };

            $scope.submit_request = function () {
                FOrder.submit_request($scope.selected_location, $scope.request.email)
                        .success(function (response) {
                            if (response.success) {
                                $scope.request.email = '';

                                if (typeof requestPopup != 'undefined') {
                                    requestPopup.close();
                                }

                                Message.show($translate.instant('open_location'));
                            }
                            else {
                                Message.show($translate.instant('an_error'));
                            }
                        });
            };

            var coverPopup;
            $scope.show_no_cover = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                coverPopup = $ionicPopup.show({
                    templateUrl: 'templates/no_cover.html',
                    title: $translate.instant('not_coverage'),
                    scope: $scope
                });
                IonicClosePopupService.register(coverPopup);

                try
                {
                    ga_storage._trackPageview('no_cover.html', 'Provider does not Cover');
                }
                catch (e)
                {
                    console.log(e.message);
                }
            };

            $scope.close_no_cover = function () {
                coverPopup.close();
            };

            $scope.new_order = function () {
                FOrder.deleteProviders();
                FOrder.deleteProvider();
                FOrder.resetOrder();
                FOrder.resetCart();
                Session.unset('previous_view');
                Session.unset('editing_order');
                Session.unset('from_map');
                $scope.adding_address = false;
                $scope.previous_view = '';

                if (coverPopup != null) {
                    coverPopup.close();
                }

                if (orderPopup != null) {
                    orderPopup.close();
                }
            };

            $scope.show_address = function () {
                $scope.loading_address = true;
                FCustomer.get_addresses(5)
                        .success(function (response) {
                            $scope.loading_address = false;
                            if (response.success) {
                                $scope.addresses = response.addresses;
                                $scope.show_list = true;
                            }
                        })
                        .error(function () {
                            $scope.loading_address = false;
                        });
            };

            $scope.hide_address = function () {
                $scope.show_list = false;
            };

            $scope.go_location = function (address) {
                var position = {lat: parseFloat(address.lat), lng: parseFloat(address.lng)};

                $scope.map.setCenter(position);
                $scope.map.setZoom(16);

                Session.set('loaded_address', address.id_address);

                $scope.geocodeLatLng();

                $scope.hide_address();
            };

            $scope.show_intercom = function () {
                if (typeof intercom != 'undefined') {
                    intercom.displayMessageComposer();
                }
            };

            // Create the login modal that we will use later
            $ionicModal.fromTemplateUrl('templates/list_areas.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.modal = modal;
            });

            // Triggered in the login modal to close it
            $scope.closeAreas = function () {
                $scope.modal.hide();
            };

            $scope.loading_areas = false;
            $scope.get_country_areas = function () {

                $scope.loading_areas = true;

                FCustomer.get_country_areas($scope.data1.selected_country)
                        .success(function (response) {
                            if (response.success) {
                                $scope.data1.areas = response.areas;
                            }
                            else {

                            }

                            $scope.loading_areas = false;
                        })
                        .error(function (error) {
                            $scope.loading_areas = false;
                        });
            };

            // Open the login modal
            $scope.show_areas = function () {
                $scope.modal.show();

                try
                {
                    ga_storage._trackPageview('show_areas.html', 'Show Areas');
                }
                catch (e)
                {
                    console.log(e.message);
                }

                $scope.get_country_areas();
            };
        })

        .controller('ScheduleCtrl', function ($scope, $state, $rootScope, $translate, Session, Auth, FOrder, $ionicModal, Message, Loading, FCustomer, $timeout, IonicClosePopupService, $ionicScrollDelegate, $ionicPopup) {

            $scope.provider = FOrder.getProvider();
            $rootScope.logged = Auth.isLogged();
            $scope.currency = $scope.provider.currency;
            $scope.default_item = 'img/default_item.png';
            $scope.from_map = Session.get('from_map') == 1;
            $scope.is_editing = parseInt(Session.get('editing_order')) > 0;

            try
            {
                ga_storage._trackPageview('schedule.html', 'Schedule');
            }
            catch (e)
            {
                console.log(e.message);
            }

            if (Auth.isLogged()) {
                $scope.customer = FCustomer.getCustomer();
            }
            else {
                $scope.customer = {
                    credit: 0
                };
            }

            $scope.load_order = function () {
                var order = FOrder.getOrder();
                if (typeof order != 'undefined' && order != null) {
                    $scope.order = order;
                }
                else {
                    $scope.order = FOrder.resetOrder();
                }

                $scope.order.formatted_address = FOrder.getAddress();
                $scope.order.id_provider = $scope.provider.id_provider;

                if (Auth.isLogged()) {
                    $scope.order.id_address = Session.get('id_address');

                    var details = Session.get('loaded_details');

                    if (typeof details != 'undefined' && details != null && details != 'undefined') {
                        $scope.order.address_details = angular.fromJson(details);
                    }
                }
                else {
                    $scope.order.id_address = 0;
                }

                FOrder.saveOrder($scope.order);

                $ionicScrollDelegate.resize();
            };

            $scope.cart = FOrder.getCart();
            $scope.load_order();

            $scope.go_set_address = function () {
                Session.set('from_schedule', 1);
                $state.go('app.set_address');
            };

            $scope.go_set_schedule = function (option) {
                var is_pickup = option == 1 ? true : false;
                Session.set('is_pickup', is_pickup);

                $state.go('app.set_schedule');
            };

            $scope.go_instructions = function () {
                $state.go('app.set_instructions');
            };

            var couponPopup;
            $scope.show_coupon = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                couponPopup = $ionicPopup.show({
                    template: '<div><input class="text-center rounded-corner" type="text" ng-model="order.coupon_code"></div> <div class="padding-top text-center positive" ng-click="reset_voucher()">Clear Voucher</div>',
                    title: $translate.instant('enter_voucher_code'),
                    subTitle: '',
                    scope: $scope,
                    buttons: [
                        {
                            text: $translate.instant('cancel'),
                            type: 'assertive-border'
                        },
                        {
                            text: $translate.instant('verify'),
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.order.coupon_code) {
                                    //don't allow the user to close unless he enters wifi password
                                    e.preventDefault();
                                }
                                else {

                                    Loading.show($translate.instant('verifying'));
                                    FOrder.check_coupon($scope.order.coupon_code)
                                            .success(function (response) {
                                                if (response.success) {
                                                    $scope.order.coupon_discount = response.discount;
                                                    $scope.order.coupon_condition = response.condition;
                                                    FOrder.saveOrder($scope.order);
                                                }
                                                else {
                                                    Message.show(response.error);
                                                }
                                            })
                                            .finally(function () {
                                                Loading.hide();
                                            });

                                    return $scope.order.coupon_code;
                                }
                            }
                        }
                    ]
                });
            };

            $scope.go_checkout = function () {

                if (!$scope.check_valid_order()) {
                    return false;
                }

                $scope.order.cart = FOrder.getCart();
                $scope.order.total_amount = $scope.calculate_total_payment();

                FOrder.saveOrder($scope.order);

                if (!Auth.isLogged()) {
                    Session.set('redirect', 'checkout');
                    $scope.login();
                }
                else {
                    $state.go('app.checkout');
                }
            };

            $scope.has_instructions = function () {

                var temp = $scope.order.instructions;

                if (temp.folded != 0 || temp.at_my_door != 0 || temp.call_pickup != 0 || temp.call_delivery != 0 || temp.message != '') {
                    return true;
                }
                return false;
            };

            $scope.get_instructions = function () {

                var inst = [];
                var temp = $scope.order.instructions;

                if (temp.folded != 0) {
                    inst.push($translate.instant('fold_clothes'));
                }
                if (temp.at_my_door != 0) {
                    inst.push($translate.instant('leave_door'));
                }
                if (temp.call_pickup != 0) {
                    inst.push($translate.instant('call_pickup'));
                }
                if (temp.call_delivery != 0) {
                    inst.push($translate.instant('call_delivery'));
                }
                if (temp.message != '') {
                    inst.push(temp.message);
                }

                return inst.join(', ');
            };

            $scope.increment = function (garment, $event) {
                $event.stopPropagation();

                garment['items']++;
                garment['partial_amount'] = garment.items * garment.price;

                if (garment.is_kg != 1) {
                    $scope.cart.total_items++;
                }
                else {
                    $scope.cart.total_kg++;
                }

                $scope.cart.total_amount += parseFloat(garment.price);
                $scope.cart.garments[garment.id_garment_has_service] = garment;
                FOrder.saveCart($scope.cart);
            };

            $scope.decrement = function (garment, $event) {
                $event.stopPropagation();

                if (garment.items > 0) {
                    garment['items']--;
                    garment['partial_amount'] = garment.items * garment.price;

                    if (garment.is_kg != 1) {
                        $scope.cart.total_items--;
                    }
                    else {
                        $scope.cart.total_kg--;
                    }

                    $scope.cart.total_amount -= parseFloat(garment.price);
                    $scope.cart.garments[garment.id_garment_has_service] = garment;

                    if (garment['items'] == 0) {
                        delete $scope.cart.garments[garment.id_garment_has_service];
                    }

                    FOrder.saveCart($scope.cart);
                }
            };

            $scope.calculate_express_fee = function () {
                if (parseFloat($scope.order.express_fee) > 0 || ($scope.is_editing && $scope.order.is_express == 1)) {
                    var fee = parseFloat($scope.cart.total_amount) * parseFloat($scope.provider.express_fee) / 100;
                    return fee.toFixed(2);
                }

                return 0;
            };

            $scope.calculate_total = function () {

                var subtotal = $scope.cart.total_amount;
                var express_fee = $scope.calculate_express_fee();
                var delivery_fee = $scope.provider.delivery_fee;

                var total = parseFloat(subtotal) + parseFloat(express_fee) + parseFloat(delivery_fee);

                if ($scope.order.coupon_discount != '') {
                    if (subtotal >= $scope.order.coupon_condition) {
                        var temp = $scope.order.coupon_discount.split(' ');
                        if (typeof temp[1] != 'undefined' && temp[1] == '%') {
                            var perc = parseFloat(subtotal) * parseFloat(temp[0]) / 100;
                            $scope.order.coupon_discounted = perc;

                            total -= parseFloat(perc);
                        }
                        else if (typeof temp[0] != 'undefined') {
                            $scope.order.coupon_discounted = temp[0];
                            total -= parseFloat(temp[0]);
                        }
                    }
                    else {
                        $scope.order.coupon_discounted = 0;
                    }
                }
                else {
                    $scope.order.coupon_discounted = 0;
                }

                total = parseFloat(total) >= 0 ? total : 0;

                return parseFloat(total).toFixed(2);
            };

            $scope.calculate_vat = function () {
                var total = $scope.calculate_total();
                if (parseFloat($scope.provider.vat) > 0) {
                    var vat = parseFloat(total) * parseFloat($scope.provider.vat) / 100;
                    return parseFloat(vat).toFixed(2);
                }

                return 0;
            };

            $scope.calculate_total_billed = function () {
                var total = $scope.calculate_total();
                var vat = $scope.calculate_vat();

                var total_billed = parseFloat(total) + parseFloat(vat);
                total_billed = parseFloat(total_billed) >= 0 ? total_billed : 0;

                return parseFloat(total_billed).toFixed(2);
            };

            $scope.calculate_credit = function () {

                var credit = typeof $scope.customer.credit != 'undefined' ? $scope.customer.credit : 0;
                var total_billed = $scope.calculate_total_billed();

                if (parseFloat(credit) > parseFloat(total_billed)) {
                    credit = total_billed;
                }

                return parseFloat(credit).toFixed(2);
            };

            $scope.calculate_total_payment = function () {
                var total_billed = $scope.calculate_total_billed();
                var credit = $scope.calculate_credit();

                var total_payment = parseFloat(total_billed) - parseFloat(credit);
                total_payment = parseFloat(total_payment) >= 0 ? total_payment : 0;

                return parseFloat(total_payment).toFixed(2);
            };

            $scope.check_valid_price = function () {

                var message = '';
                var pro_has_kg = parseFloat($scope.provider.minimum_kg) > 0;
                var cart_has_kg = parseFloat($scope.cart.total_kg) > 0;
                var m_min = $translate.instant('minimum') + ' ' + $scope.provider.minimum_amount + ' ' + $scope.provider.currency;
                var m_min_kg = $translate.instant('minimum_kg') + ' ' + $scope.provider.minimum_kg + ' Kg';

                if (parseFloat($scope.cart.total_amount) == 0) {
                    return true;
                }
                else if (parseFloat($scope.cart.total_amount) < parseFloat($scope.provider.minimum_amount)) {
                    if (pro_has_kg) {
                        if (cart_has_kg) {
                            if (parseFloat($scope.cart.total_kg) < parseFloat($scope.provider.minimum_kg)) {
                                message = m_min_kg;
                                Message.alert(message);
                                return false;
                            }
                            else {
                                return true;
                            }
                        }
                        else {
                            message = m_min;
                            Message.alert(message);
                            return false;
                        }
                    }
                    else {
                        message = m_min;
                        Message.alert(message);
                        return false;
                    }
                }
                else {
                    return true;
                }

                return true;
            };

            $scope.check_valid_order = function () {

                var invalid = !$scope.order.formatted_address || !$scope.order.address_details.name || !$scope.order.pickup_date || !$scope.order.delivery_date;

                if (invalid) {
                    Message.show($translate.instant('complete_required') + ' <span class="assertive">(' + $translate.instant('in_red') + ')</span>');
                    return false;
                }

                if (!$scope.check_valid_price()) {
                    return false;
                }

                return !invalid;
            };

            $scope.show_verify_2 = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                $scope.customer.verification = '';

                var myPopup = $ionicPopup.show({
                    template: '<div class="text-center positive"><input class="text-center rounded-corner" type="number" ng-model="customer.verification"> <div class="padding-top" ng-click="resend_verification_2()"><i class="icon ion-ios-refresh-outline"></i> Resend Verification Code</div> </div>',
                    title: $translate.instant('enter_verification_code'),
                    subTitle: $scope.customer.new_contact ? $scope.customer.new_contact : $scope.customer.contact,
                    scope: $scope,
                    buttons: [
                        {
                            text: $translate.instant('cancel'),
                            type: 'assertive-border',
                            onTap: function (e) {
                                $scope.customer.verification = '';
                            }
                        },
                        {
                            text: $translate.instant('submit'),
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.customer.verification) {
                                    e.preventDefault();
                                }
                                else {

                                    Loading.show($translate.instant('updating_number'));
                                    FCustomer.change_contact($scope.customer.new_contact, $scope.customer.verification)
                                            .success(function (response) {
                                                if (response.success) {
                                                    $scope.customer.contact = response.new_contact;
                                                    $scope.customer.verified = 1;
                                                    FCustomer.saveCustomer($scope.customer);

                                                    $scope.customer = FCustomer.getCustomer();

                                                    Message.show($translate.instant('number_verified'));
                                                }
                                                else {
                                                    Message.show(response.error);
                                                }
                                            })
                                            .finally(function () {
                                                Loading.hide();
                                            });

                                    return $scope.customer.verification;
                                }
                            }
                        }
                    ]
                });
            };

            $scope.resend_verification_2 = function () {
                Loading.show($translate.instant('requesting_code'));

                var contact = $scope.customer.new_contact ? $scope.customer.new_contact : $scope.customer.contact;

                FCustomer.resend_verification(contact)
                        .success(function (response) {
                            if (response.success) {
                                Message.show($translate.instant('sent_verification'));
                            }
                            else {
                                Message.show(response.error);
                            }
                        })
                        .finally(function () {
                            Loading.hide();
                        });
            };

            $scope.show_new_contact_2 = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                $scope.customer.new_contact = '';
                var myPopup = $ionicPopup.show({
                    template: '<intlpn class="rounded-corner" ng-model="customer.new_contact" placeholder="Contact Number" default-country="ae" ></intlpn>',
                    title: $translate.instant('enter_new_number'),
                    subTitle: '',
                    scope: $scope,
                    buttons: [
                        {
                            text: $translate.instant('cancel'),
                            type: 'assertive-border'
                        },
                        {
                            text: $translate.instant('submit'),
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.customer.new_contact) {
                                    e.preventDefault();
                                }
                                else {

                                    setTimeout(function () {
                                        $scope.show_verify_2();

                                        setTimeout(function () {
                                            $scope.resend_verification_2();
                                        }, 1000);

                                    }, 500);

                                    return $scope.customer.new_contact;
                                }
                            }
                        }
                    ]
                });

                IonicClosePopupService.register(myPopup);
            };

            $ionicModal.fromTemplateUrl('templates/complete_address.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.modalAddress = modal;
            });

            // Triggered in the login modal to close it
            $scope.closeAddress = function () {
                if ($scope.order.address_details.name == '' || $scope.order.address_details.building == '' || $scope.order.address_details.unit == '' || $scope.order.address_details.street == '') {
                    $scope.order.address_details = {
                        name: '',
                        building: '',
                        unit: '',
                        street: '',
                        indications: ''
                    };
                }
                else {
                    Session.set('loaded_details', angular.toJson($scope.order.address_details));
                }

                $scope.modalAddress.hide();
            };

            // Open the login modal
            $scope.show_complete_address = function () {

                $scope.order.address_details.name = $scope.order.address_details.name == '' ? 'Home' : $scope.order.address_details.name;

                $scope.modalAddress.show();
            };

            $scope.expandText = function () {
                var element = document.getElementById("message");
                element.style.height = element.scrollHeight + "px";
            };

            $scope.save_address = function () {
                FOrder.saveOrder($scope.order);
                $scope.closeAddress();
            };

            $scope.change_address_type = function (type) {
                $scope.order.address_details.name = type;
                FOrder.saveOrder($scope.order);
            };

            $scope.refresh_customer = function () {
                FCustomer.get_info()
                        .success(function (response) {
                            $scope.$broadcast('scroll.refreshComplete');
                            if (response.customer) {
                                $scope.customer = response.customer;
                                FCustomer.saveCustomer(customer);

                                $scope.order.credit = customer.credit;
                            }
                        })
                        .error(function () {
                            $scope.$broadcast('scroll.refreshComplete');
                        });
            };

            $scope.reset_voucher = function () {
                $scope.order.coupon_code = '';
                $scope.order.coupon_discount = '';
                $scope.order.coupon_condition = 0;
                $scope.order.coupon_discounted = 0;

                FOrder.saveOrder($scope.order);

                couponPopup.close();
            };

            $scope.ask_cancel = function () {
                var title = $translate.instant('cancel_editing') + ' #' + Session.get('editing_order');
                var message = $translate.instant('stop_editing');

                Message.confirm(title, message).then(function (res) {
                    if (res === true || res == 2) {

                        FOrder.deleteProviders();
                        FOrder.deleteProvider();
                        FOrder.resetOrder();
                        FOrder.resetCart();
                        Session.unset('previous_view');
                        Session.unset('editing_order');
                        $scope.adding_address = false;
                        $scope.previous_view = '';

                        $state.go('app.map');
                    }
                });
            };
        })

        .controller('SetScheduleCtrl', function ($scope, $state, FOrder, Session, Message, $translate) {

            $scope.data = {};
            $scope.order = FOrder.getOrder();
            $scope.provider = FOrder.getProvider();
            $scope.loading = false;
            $scope.is_express = false;
            $scope.data.active_time = '';

            $scope.is_pickup = Session.get('is_pickup') == 'true' ? true : false;
            $scope.service = Session.get('is_pickup') == 'true' ? $translate.instant('pickup') : $translate.instant('delivery');

            var pickup_info = {
                is_pickup: $scope.is_pickup,
                pickup_date: $scope.order.pickup_date,
                pickup_time: $scope.order.pickup_time
            };

            try
            {
                ga_storage._trackPageview('set_schedule.html', 'Set Pickup/Delivery');
            }
            catch (e)
            {
                console.log(e.message);
            }

            $scope.load_schedule = function () {
                $scope.loading = true;

                FOrder.get_provider_schedule($scope.provider.id_provider, pickup_info)
                        .success(function (response) {
                            if (response.success) {
                                $scope.days = response.schedule.days;

                                if ($scope.is_pickup) {
                                    if ($scope.order.pickup_date != '') {
                                        $scope.active_day = $scope.order.pickup_date;
                                        $scope.data.active_date_formatted = $scope.order.pickup_date_formatted;
                                        $scope.data.active_time = $scope.order.pickup_time;
                                    }
                                    else {
                                        $scope.active_day = $scope.days[0].value;
                                        $scope.data.active_date_formatted = $scope.days[0].formatted;

                                        if (typeof $scope.days[0].times != 'undefined') {
                                            $scope.data.active_time = $scope.days[0].times[0].value;
                                        }
                                    }
                                }
                                else {
                                    if ($scope.order.delivery_date != '') {
                                        $scope.active_day = $scope.order.delivery_date;
                                        $scope.data.active_date_formatted = $scope.order.delivery_date_formatted;
                                        $scope.data.active_time = $scope.order.delivery_time;

                                        if ($scope.order.express_fee > 0) {
                                            $scope.is_express = true;
                                        }
                                    }
                                    else {
                                        $scope.active_day = $scope.days[0].value;
                                        $scope.data.active_date_formatted = $scope.days[0].formatted;

                                        if (typeof $scope.days[0].times != 'undefined') {
                                            $scope.data.active_time = $scope.days[0].times[0].value;

                                            if ($scope.days[0].times[0].express) {
                                                $scope.is_express = true;
                                            }
                                        }
                                    }
                                }
                            }
                        }).
                        finally(function () {
                            $scope.loading = false;
                            $scope.$broadcast('scroll.refreshComplete');
                        });
            };

            $scope.load_schedule();

            $scope.change_day = function (day) {
                $scope.active_day = day.value;
                $scope.data.active_date_formatted = day.formatted;
                $scope.data.active_time = '';
            };

            $scope.update_express = function (time) {
                if ($scope.is_pickup) {
                    return false;
                }
                else {
                    $scope.is_express = time.express;
                }
            };

            $scope.get_day_times = function () {

                var times = [];
                if (typeof $scope.days != 'undefined' && $scope.days.length > 0) {
                    times = $scope.days[0].times;

                    angular.forEach($scope.days, function (day, key) {
                        if (day.value == $scope.active_day) {
                            times = day.times;
                        }
                    });
                }

                return times;
            };

            $scope.save_schedule = function () {

                if ($scope.data.active_time == '') {
                    Message.show($translate.instant('time_of') + ' ' + $scope.service);
                    return false;
                }

                if (Session.get('is_pickup') == 'true') // Pickup
                {
                    $scope.order.pickup_date = $scope.active_day;
                    $scope.order.pickup_date_formatted = $scope.data.active_date_formatted;
                    $scope.order.pickup_time = $scope.data.active_time;

                    $scope.order.delivery_date = '';
                    $scope.order.delivery_date_formatted = '';
                    $scope.order.delivery_time = '';
                }
                else {
                    $scope.order.delivery_date = $scope.active_day;
                    $scope.order.delivery_date_formatted = $scope.data.active_date_formatted;
                    $scope.order.delivery_time = $scope.data.active_time;
                    $scope.order.express_fee = 0;
                    if ($scope.is_express) {
                        $scope.order.is_express = 1;
                        $scope.order.express_fee = $scope.provider.express_fee;
                    }
                    else {
                        $scope.order.is_express = 0;
                    }
                }

                FOrder.saveOrder($scope.order);
                $state.go('app.schedule');
            };
        })

        .controller('SetInstructionsCtrl', function ($scope, $state, FOrder) {

            $scope.$on('$ionicView.afterEnter', function () {
                $scope.expandText();
            });
            $scope.order = FOrder.getOrder();
            $scope.provider = FOrder.getProvider();

            try
            {
                ga_storage._trackPageview('set_instructions.html', 'Set Instructions');
            }
            catch (e)
            {
                console.log(e.message);
            }

            $scope.save_message = function () {
                $scope.save_instructions();

                $state.go('app.schedule');
            };

            $scope.save_instructions = function () {
                FOrder.saveOrder($scope.order);
            };
            $scope.expandText = function () {
                var element = document.getElementById("message");
                element.style.height = element.scrollHeight + "px";
            };
        })

        .controller('SetAddressCtrl', function ($scope, $state, Session, FOrder, FCustomer, Auth) {

            $scope.loading = false;
            $scope.addresses = [];
            $scope.data = {
                active_address: ''
            };
            $scope.order = FOrder.getOrder();

            try
            {
                ga_storage._trackPageview('set_address.html', 'Set Address');
            }
            catch (e)
            {
                console.log(e.message);
            }

            $scope.$on("$ionicView.enter", function (event, data) {
                $scope.load_address();
            });

            $scope.load_address = function () {
                $scope.loading = true;
                $scope.addresses = [];

                if (Auth.isLogged()) {
                    FCustomer.get_addresses()
                            .success(function (response) {
                                if (response.success) {
                                    $scope.addresses = response.addresses;

                                    $scope.data.active_address = Session.get('id_address');

                                    var new_address = {
                                        id_address: $scope.data.active_address,
                                        formatted: $scope.order.formatted_address
                                    };

                                    $scope.set_active_address(new_address);
                                }
                            })
                            .finally(function () {
                                $scope.$broadcast('scroll.refreshComplete');
                                $scope.loading = false;
                            });
                }
                else {
                    var address = Session.get('formatted_address');

                    var new_address = {
                        id_address: 0,
                        formatted: address
                    };

                    $scope.addresses.push(new_address);

                    $scope.set_active_address(new_address);

                    $scope.loading = false;
                    $scope.$broadcast('scroll.refreshComplete');
                }
            };

            $scope.set_active_address = function (address) {
                $scope.order.id_address = address.id_address;
                $scope.order.formatted_address = address.formatted;

                Session.set('formatted_address', address.formatted);
                Session.set('id_address', address.id_address);

                if (address.id_address > 0) {
                    var details = {
                        name: address.name,
                        building: address.building,
                        unit: address.unit,
                        street: address.street,
                        indications: address.indications,
                    };

                    Session.set('loaded_details', angular.toJson(details));
                    $scope.order.address_details = details;
                }

                FOrder.saveOrder($scope.order);

                if (Session.get('from_schedule') != 1) {
                    $state.go('app.schedule');
                }
                else {
                    Session.unset('from_schedule');
                }
            };

            $scope.go_add_address = function () {
                Session.set('previous_view', 'schedule');
                $state.go('app.map');
            };
        })

        .controller('CheckoutCtrl', function ($scope, $state, $rootScope, $ionicModal, $translate, $timeout, FOrder, Session, Common, IonicClosePopupService, Auth, FCustomer, $ionicPopup, Loading, Message) {

            $scope.loading_terms = false;
            $scope.loading_cards = false;
            $scope.cards = [];
            $scope.my_card = {
                selection: ''
            };
            $scope.payment_option = {
                checked: true
            };
            $scope.save_card = {
                checked: true
            };
            $rootScope.logged = Auth.isLogged();

            try
            {
                ga_storage._trackPageview('checkout.html', 'Checkout');
            }
            catch (e)
            {
                console.log(e.message);
            }

            $scope.order = FOrder.getOrder();
            $scope.customer = FCustomer.getCustomer();
            $scope.provider = FOrder.getProvider();

            $scope.is_editing = parseInt(Session.get('editing_order')) > 0;

            $scope.show_verify_3 = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                $scope.customer.verification = '';

                var myPopup = $ionicPopup.show({
                    template: '<div class="text-center positive"><input class="text-center rounded-corner" type="number" ng-model="customer.verification"> <div class="padding-top" ng-click="resend_verification_3()"><i class="icon ion-ios-refresh-outline"></i> Resend Verification Code</div> </div>',
                    title: $translate.instant('enter_verification_code'),
                    subTitle: $scope.customer.new_contact ? $scope.customer.new_contact : $scope.customer.contact,
                    scope: $scope,
                    buttons: [
                        {
                            text: $translate.instant('cancel'),
                            type: 'assertive-border',
                            onTap: function (e) {
                                $scope.customer.verification = '';
                            }
                        },
                        {
                            text: $translate.instant('submit'),
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.customer.verification) {
                                    e.preventDefault();
                                }
                                else {

                                    Loading.show('Verifying...');
                                    FCustomer.change_contact($scope.customer.new_contact, $scope.customer.verification)
                                            .success(function (response) {
                                                if (response.success) {
                                                    $scope.customer.verified = 1;
                                                    FCustomer.saveCustomer($scope.customer);

                                                    $scope.customer = FCustomer.getCustomer();

                                                    $translate.instant('number_verified');
                                                }
                                                else {
                                                    Message.show(response.error);
                                                }
                                            })
                                            .finally(function () {
                                                Loading.hide();
                                            });

                                    return $scope.customer.verification;
                                }
                            }
                        }
                    ]
                });
            };

            $scope.show_new_contact_3 = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                $scope.customer.new_contact = '';
                var myPopup = $ionicPopup.show({
                    template: '<intlpn class="rounded-corner" ng-model="customer.new_contact" placeholder="Contact Number" default-country="ae" ></intlpn>',
                    title: $translate.instant('enter_new_number'),
                    subTitle: '',
                    scope: $scope,
                    buttons: [
                        {
                            text: $translate.instant('cancel'),
                            type: 'assertive-border'
                        },
                        {
                            text: $translate.instant('submit'),
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.customer.new_contact) {
                                    e.preventDefault();
                                }
                                else {

                                    setTimeout(function () {
                                        $scope.show_verify_3();

                                        setTimeout(function () {
                                            $scope.resend_verification_3();
                                        }, 1000);

                                    }, 500);

                                    return $scope.customer.new_contact;
                                }
                            }
                        }
                    ]
                });

                IonicClosePopupService.register(myPopup);
            };

            $scope.resend_verification_3 = function () {
                Loading.show($translate.instant('requesting_code'));

                var contact = $scope.customer.new_contact ? $scope.customer.new_contact : $scope.customer.contact;

                FCustomer.resend_verification(contact)
                        .success(function (response) {
                            if (response.success) {
                                Message.show($translate.instant('sent_verification'));
                            }
                            else {
                                Message.show(response.error);
                            }
                        })
                        .finally(function () {
                            Loading.hide();
                        });
            };

            if ($scope.customer.verified != 1) {
                Message.show($translate.instant('please_verify'));
            }

            $scope.show_terms = function () {
                if (!$scope.terms) {
                    $scope.loading_terms = true;
                    Common.get_terms()
                            .success(function (response) {
                                $scope.loading_terms = false;
                                if (response.success) {
                                    $scope.terms = response.terms;
                                }
                            })
                            .error(function () {
                                $scope.loading_terms = false;
                            });
                }
                else {
                    $scope.loading_terms = false;
                }
            };

            $scope.load_cards = function () {

                $scope.no_cards = true;

                $scope.loading_cards = true;
                FCustomer.get_cards()
                        .success(function (response) {
                            if (response.success) {
                                $scope.cards = response.customer_cards;
                                if ($scope.cards.length > 0) {
                                    $scope.no_cards = false;
                                    $scope.my_card.selection = $scope.cards[0].id_card;
                                    $scope.payment_option.checked = true;
                                }
                                else {
                                    $scope.no_cards = true;
                                    $scope.payment_option.checked = false;
                                }
                            }
                            else {
                                Message.show(response.error);
                            }

                            $scope.loading_cards = false;
                            $scope.$broadcast('scroll.refreshComplete');
                        })
                        .error(function () {
                            $scope.loading_cards = false;
                            $scope.$broadcast('scroll.refreshComplete');
                        });
            };

            $scope.get_card_class = function (card_type) {
                var card_class = '';

                if (card_type == 'Visa') {
                    card_class = 'card-visa';
                }
                else if (card_type == 'MasterCard') {
                    card_class = 'card-mastercard';
                }
                else if (card_type == 'American Express') {
                    card_class = 'card-amex';
                }
                else if (card_type == 'Diners Club') {
                    card_class = 'card-dinersclub';
                }
                else if (card_type == 'JCB') {
                    card_class = 'card-jcb';
                }
                else if (card_type == 'Maestro') {
                    card_class = 'card-discover';
                }

                return card_class;
            };

            if (Auth.isLogged()) {
                $scope.load_cards();
            }

            $scope.submit_payment = function () {
                if ($scope.payment_option.checked) {
                    var payment_details = {
                        selected_card: $scope.my_card.selection
                    };

                    $scope.order.payment_data = payment_details;
                    $scope.order.payment_method = 'online';

                    if (typeof $scope.order.id_address == 'undefined' || $scope.order.id_address == '' || $scope.order.id_address == null) {
                        $scope.order.location = Session.get('location');
                    }

                    $scope.place_order($scope.order);
                }
                else {
                    Loading.show($translate.instant('loading'));
                }
            };

            $ionicModal.fromTemplateUrl('templates/rate_order.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.modalAddress = modal;
            });

            // Triggered in the login modal to close it
            $scope.close_rate = function () {
                $scope.modalAddress.hide();
            };

            $scope.expandText = function () {
                var element = document.getElementById("message");
                element.style.height = element.scrollHeight + "px";
            };

            // Open the login modal
            $scope.show_rate = function () {
                $scope.modalAddress.show();
                $scope.expandText();
            };

            $scope.rate = function (stars) {
                $scope.order.rating = stars;
            };

            $scope.save_rating = function () {

                var rating = {
                    stars: $scope.order.rating,
                    review: $scope.order.review
                };

                Loading.show($translate.instant('loading'));
                FCustomer.save_rating($scope.order.id_order, rating)
                        .success(function (response) {

                            Loading.hide();

                            if (response.success) {
                                //Message.show($translate.instant('thanks_feedback'));
                                $scope.close_rate();

                                try
                                {
                                    ga_storage._trackPageview('save_rating.html', 'Save Rating');
                                }
                                catch (e)
                                {
                                    console.log(e.message);
                                }
                            }
                            else {
                                Message.show(response.error);
                            }
                        })
                        .error(function () {
                            Loading.hide();
                        });
            };

            $scope.place_order = function (order) {
                Loading.show($translate.instant('loading'), 20000);

                FOrder.place_order(order)
                        .success(function (response) {
                            Loading.hide();

                            if (response.success) {
                                var customer = response.customer;
                                FCustomer.saveCustomer(customer);

                                $scope.go_success(response.id_order);
                            }
                            else {

                                if (response.error == 'PENDING') {

                                    Message.show('We appreciate your feedback. Please take a moment to rate your previous order');

                                    $scope.order.id_order = response.order.id_order;
                                    $scope.order.driver = {
                                        img: response.order.driver_img,
                                        firstname: response.order.driver
                                    };
                                    $scope.order.laundry = response.order.laundry;
                                    $scope.order.rating = 0;

                                    $scope.show_rate();
                                }
                                else {
                                    Message.show(response.error);
                                }
                            }
                        })
                        .error(function () {
                            Message.show('An error occurred, please try again');
                        });

            };

            $scope.go_add_payment = function () {
                Session.set('after_add_card', 'checkout');
                $state.go('app.add_payment');
            };

            $scope.ask_cancel = function () {
                var title = $translate.instant('cancel_editing') + ' #' + Session.get('editing_order');
                var message = $translate.instant('stop_editing');

                Message.confirm(title, message).then(function (res) {
                    if (res === true || res == 2) {

                        FOrder.deleteProviders();
                        FOrder.deleteProvider();
                        FOrder.resetOrder();
                        FOrder.resetCart();
                        Session.unset('previous_view');
                        Session.unset('editing_order');
                        $scope.adding_address = false;
                        $scope.previous_view = '';

                        $state.go('app.map');
                    }
                });
            };

            $scope.go_success = function (id_order) {

                FOrder.deleteOrder();
                FOrder.deleteProvider();
                FOrder.deleteProviders();
                FOrder.resetCart();
                Session.unset('editing_order');

                try
                {
                    ga_storage._trackPageview('order_success.html', 'Order Success');
                }
                catch (e)
                {
                    console.log(e.message);
                }

                $state.go('app.success', {id_order: id_order});
            };

            $scope.pay_cash = function () {

                if (Auth.isLogged()) {
                    $scope.customer = FCustomer.getCustomer();

                    if (!$scope.customer.contact) {
                        $scope.show_new_contact_2();
                    }
                    else if ($scope.customer.verified == '1') {
                        var title = $translate.instant('confirm_submission');
                        var message = $translate.instant('sure_submit');

                        Message.confirm(title, message).then(function (res) {
                            if (res === true || res == 2) {
                                Loading.show($translate.instant('loading'), 20000);

                                $scope.order.cart = FOrder.getCart();
                                $scope.order.payment_method = 'cash';

                                if (typeof $scope.order.id_address == 'undefined' || $scope.order.id_address == '') {
                                    $scope.order.location = Session.get('location');
                                }

                                // TODO: Check if necessary
                                FOrder.saveOrder($scope.order);

                                FOrder.place_order($scope.order)
                                        .success(function (response) {
                                            if (response.success) {
                                                var customer = response.customer;
                                                FCustomer.saveCustomer(customer);

                                                $scope.go_success(response.id_order);
                                            }
                                            else {
                                                Message.show(response.error);
                                            }
                                        })
                                        .finally(function () {
                                            Loading.hide();
                                        });
                            }
                        });
                    }
                    else {
                        $scope.show_verify_2();

                        Message.show($translate.instant('please_verify'));
                    }
                }
                else {
                    Session.set('redirect', 'cash');
                    $scope.login();
                }
            };

            $scope.is_not_valid_form = function () {

                if ($scope.payment_option.checked) {
                    if ($scope.my_card.selection) {
                        return false;
                    }
                    else {
                        return true;
                    }
                }

                return true;
            };
        })

        .controller('SuccessCtrl', function ($scope, $state, $stateParams) {

            $scope.id_order = $stateParams.id_order;

            $scope.go_view_order = function () {
                $state.go('app.view_order', {id_order: $scope.id_order});
            };

        })

        .controller('SupportCtrl', function ($scope, FCustomer, APP_VERSION) {
            $scope.loading = false;

            $scope.load_support = function () {
                $scope.loading = true;

                FCustomer.get_support()
                        .success(function (response) {
                            if (response.success) {
                                $scope.support = {
                                    contact: response.contact,
                                    email: response.email,
                                    website: response.website
                                };

                                $scope.version = APP_VERSION;
                            }

                            $scope.loading = false;
                        });
            };

            $scope.load_support();

            $scope.show_intercom = function () {
                if (typeof intercom != 'undefined') {
                    intercom.displayMessageComposer();
                }
            };

            try
            {
                ga_storage._trackPageview('support.html', 'Support');
            }
            catch (e)
            {
                console.log(e.message);
            }
        })

        .controller('TipsCtrl', function ($state, $stateParams, $scope, Session) {
            try
            {
                ga_storage._trackPageview('tips.html', 'Tips');
            }
            catch (e)
            {
                console.log(e.message);
            }

            $scope.from_menu = $stateParams.from_menu;
            if ($scope.from_menu == 1) {
            }
            else {
                if (Session.get('viewed_tips') == 1) {
                    $state.go('app.map');
                    return false;
                }
                else {
                    Session.set('viewed_tips', 1);
                }
            }

            $scope.go_map = function () {
                $state.go('app.map');
            };
        })

        .controller('FaqCtrl', function ($scope, Common) {
            $scope.loading = true;

            $scope.load_faq = function () {
                Common.get_faq()
                        .success(function (response) {
                            $scope.faq = response.faq;
                        })
                        .finally(function () {
                            $scope.$broadcast('scroll.refreshComplete');
                            $scope.loading = false;
                        });
            };

            $scope.load_faq();

            try
            {
                ga_storage._trackPageview('faq.html', 'Faq');
            }
            catch (e)
            {
                console.log(e.message);
            }
        })

        .controller('TermsCtrl', function ($scope, Common) {

            $scope.loading = true;

            $scope.load_terms = function () {
                Common.get_terms()
                        .success(function (response) {
                            $scope.terms = response.terms;
                        })
                        .finally(function () {
                            $scope.$broadcast('scroll.refreshComplete');
                            $scope.loading = false;
                        });
            };

            $scope.load_terms();

            try
            {
                ga_storage._trackPageview('terms.html', 'Terms');
            }
            catch (e)
            {
                console.log(e.message);
            }
        })

        .controller('InternetCtrl', function ($state, $scope, $ionicSideMenuDelegate) {

            $scope.$on("$ionicView.enter", function (event, data) {
                if ($ionicSideMenuDelegate.isOpen()) {
                    $ionicSideMenuDelegate.toggleLeft();
                }
            });

            $scope.try_again = function () {
                $state.go('app.map');
            };
        })

        .controller('BusinessCtrl', function ($scope, $translate, Message, Loading, Common) {

            $scope.provider = {};
            $scope.is_not_valid_form = function () {

                var invalid = !$scope.provider.firstname || !$scope.provider.lastname || !$scope.provider.email || !$scope.provider.laundry || !$scope.provider.contact;
                return invalid;
            };

            try
            {
                ga_storage._trackPageview('business.html', 'Business');
            }
            catch (e)
            {
                console.log(e.message);
            }

            $scope.submit = function () {
                Loading.show('Sending...');

                Common.business_request($scope.provider)
                        .success(function (response) {
                            if (response.success) {
                                $scope.provider = {};
                                Message.show($translate.instant('touch_soon'));

                                try
                                {
                                    ga_storage._trackPageview('new_business.html', 'New Business');
                                }
                                catch (e)
                                {
                                    console.log(e.message);
                                }
                            }
                            else {
                                Message.show(response.error);
                            }
                        })
                        .finally(function () {
                            Loading.hide();
                        });


            };
        })

        .controller('LanguagesCtrl', function ($scope, $translate, FCustomer, Session, Language, Message) {

            $scope.languages = [];
            $scope.view_ready = false;
            $scope.data = {};

            $scope.load_languages = function () {
                FCustomer.get_languages()
                        .success(function (response) {
                            if (response.success) {
                                $scope.languages = response.languages;

                                var language = Session.get('language');
                                $scope.data.active_language = language;
                            }
                        })
                        .finally(function () {
                            $scope.view_ready = true;
                            $scope.$broadcast('scroll.refreshComplete');
                        });
            };

            $scope.load_languages();

            $scope.change_language = function (language) {
                Session.set('language', language.acronym);
                $scope.data.active_language = language.acronym;
                Language.setLanguage(language.acronym);


                Message.show($translate.instant('language_changed'));
            };

            try
            {
                ga_storage._trackPageview('language.html', 'Language');
            }
            catch (e)
            {
                console.log(e.message);
            }
        })

        .controller('BranchCtrl', function (Session, $translate, $rootScope, $state, Message, Auth, $ionicSideMenuDelegate, Loading, FCustomer, Intercom, Language) {

            try
            {
                ga_storage._trackPageview('branch.html', 'Branch');
            }
            catch (e)
            {
                console.log(e.message);
            }

            Loading.show($translate.instant('loading'));

            var branch = angular.fromJson(Session.get('branch'));
            Session.unset('branch');

            console.log(branch);

            var page = branch.redirect;
            var params = branch.params;

            if (page) {
                if (!Auth.isLogged()) {
                    if (branch.api_signature) {
                        console.log('branch login');
                        FCustomer.login_branch(branch.api_signature)
                                .success(function (response) {
                                    Loading.hide();
                                    if (response.success) {
                                        $rootScope.logged = true;

                                        Session.set('access', 'OK');
                                        Session.set('api_signature', response.customer.api_signature);

                                        FCustomer.saveCustomer(response.customer);

                                        setTimeout(function () {
                                            var elem = document.getElementById('user_name');

                                            if (typeof elem != 'undefined' && elem != null) {
                                                elem.innerHTML = response.customer.firstname + ' ' + response.customer.lastname;
                                            }
                                        }, 2000);

                                        Intercom.init();
                                        Language.setLanguage(response.customer.language);

                                        if ($ionicSideMenuDelegate.isOpen()) {
                                            $ionicSideMenuDelegate.toggleLeft();
                                        }

                                        $state.go(page, params);
                                    }
                                    else {
                                        Message.show(response.error);
                                    }
                                })
                                .error(function () {
                                    Loading.hide();
                                    $state.go(page, params);
                                });
                    }
                    else {
                        Loading.hide();
                        $state.go(page, params);
                    }
                }
                else {
                    Loading.hide();
                    $state.go(page, params);
                }
            }
        });
