angular.module('getlaundry.customers_controller', [])

        .controller('AccountCtrl', function ($scope, $state, $translate, $ionicPopup, $timeout, Message, Loading, FCustomer, $cordovaCamera, $ionicActionSheet, IonicClosePopupService) {

            $scope.password_type = true;
            $scope.customer = FCustomer.getCustomer();
            $scope.saving_img = false;
            $scope.default_user = 'img/default_user.png';

            $scope.go_addresses = function () {
                $state.go('app.addresses');
            };

            $scope.go_preferences = function () {
                $state.go('app.preferences');
            };

            $scope.go_cards = function () {
                $state.go('app.cards');
            };

            $scope.change_password = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                $scope.customer.new_password = '';

                var myPopup = $ionicPopup.show({
                    template: '<input class="text-center rounded-corner" type="password" ng-model="customer.new_password">',
                    title: $translate.instant('new_password'),
                    subTitle: '',
                    scope: $scope,
                    buttons: [
                        {
                            text: $translate.instant('cancel'),
                            type: 'assertive-border'
                        },
                        {
                            text: $translate.instant('submit'),
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.customer.new_password) {
                                    e.preventDefault();
                                }
                                else {

                                    Loading.show($translate.instant('updating_password'));
                                    FCustomer.change_password($scope.customer.new_password)
                                            .success(function (response) {
                                                if (response.success) {
                                                    Message.show($translate.instant('password_updated'));
                                                }
                                                else {
                                                    Message.show(response.error);
                                                }
                                            })
                                            .finally(function () {
                                                Loading.hide();
                                            });

                                    return $scope.customer.new_password;
                                }
                            }
                        }
                    ]
                });

                IonicClosePopupService.register(myPopup);
            };

            $scope.show_new_contact = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                $scope.customer.new_contact = '';

                var myPopup = $ionicPopup.show({
                    template: '<intlpn class="rounded-corner" ng-model="customer.new_contact" placeholder="Contact Number" default-country="ae" ></intlpn>',
                    title: $translate.instant('enter_new_number'),
                    subTitle: '',
                    scope: $scope,
                    buttons: [
                        {
                            text: $translate.instant('cancel'),
                            type: 'assertive-border'
                        },
                        {
                            text: $translate.instant('submit'),
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.customer.new_contact) {
                                    e.preventDefault();
                                }
                                else {

                                    setTimeout(function () {
                                        $scope.show_verify();

                                        setTimeout(function () {
                                            $scope.resend_verification();
                                        }, 1000);

                                    }, 500);

                                    return $scope.customer.new_contact;
                                }
                            }
                        }
                    ]
                });

                IonicClosePopupService.register(myPopup);
            };

            $scope.show_verify = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                $scope.customer.verification = '';

                var myPopup = $ionicPopup.show({
                    template: '<div class="text-center positive"><input class="text-center rounded-corner" type="number" ng-model="customer.verification"> <div class="padding-top" ng-click="resend_verification()"><i class="icon ion-ios-refresh-outline"></i> Resend Verification Code</div> </div>',
                    title: $translate.instant('enter_verification_code'),
                    subTitle: $scope.customer.new_contact ? $scope.customer.new_contact : $scope.customer.contact,
                    scope: $scope,
                    buttons: [
                        {
                            text: $translate.instant('cancel'),
                            type: 'assertive-border',
                            onTap: function (e) {
                                $scope.customer.verification = '';
                            }
                        },
                        {
                            text: $translate.instant('submit'),
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.customer.verification) {
                                    e.preventDefault();
                                }
                                else {

                                    Loading.show($translate.instant('updating_number'));
                                    FCustomer.change_contact($scope.customer.new_contact, $scope.customer.verification)
                                            .success(function (response) {
                                                if (response.success) {
                                                    $scope.customer.contact = response.new_contact;
                                                    $scope.customer.verified = 1;
                                                    FCustomer.saveCustomer($scope.customer);

                                                    Message.show($translate.instant('contact_updated'));
                                                }
                                                else {
                                                    Message.show(response.error);
                                                }
                                            })
                                            .finally(function () {
                                                Loading.hide();
                                            });

                                    return $scope.customer.verification;
                                }
                            }
                        }
                    ]
                });
            };

            $scope.resend_verification = function () {
                Loading.show($translate.instant('requesting_code'));

                var contact = $scope.customer.new_contact ? $scope.customer.new_contact : $scope.customer.contact;

                FCustomer.resend_verification(contact)
                        .success(function (response) {
                            if (response.success) {
                                Message.show($translate.instant('sent_verification'));
                            }
                            else {
                                Message.show(response.error);
                            }
                        })
                        .finally(function () {
                            Loading.hide();
                        });
            };

            $scope.takePicture = function (mode) {
                var source = mode == 1 ? Camera.PictureSourceType.CAMERA : Camera.PictureSourceType.PHOTOLIBRARY;

                var options = {
                    quality: 75,
                    destinationType: Camera.DestinationType.DATA_URL,
                    sourceType: source,
                    allowEdit: true,
                    encodingType: Camera.EncodingType.JPEG,
                    targetWidth: 250,
                    targetHeight: 250,
                    popoverOptions: CameraPopoverOptions,
                    saveToPhotoAlbum: false
                };

                // update camera image directive
                $cordovaCamera.getPicture(options).then(function (imageData) {
                    $scope.customer.img = "data:image/jpeg;base64," + imageData;
                    document.getElementById('main_img').src = $scope.customer.img;

                    FCustomer.save_profile($scope.customer)
                            .success(function (response) {
                                if (response.success) {
                                    FCustomer.saveCustomer($scope.customer);
                                }
                                else {
                                    Message.show(response.error);
                                }
                            });
                }, function (err) {
                    //Message.show('Failed');
                });
            };

            $scope.change_picture = function () {

                // Show the action sheet
                var hideSheet = $ionicActionSheet.show({
                    buttons: [
                        {text: $translate.instant('take_photo')},
                        {text: $translate.instant('photo_library')}
                    ],
                    titleText: $translate.instant('profile_picture'),
                    cancelText: $translate.instant('cancel'),
                    cancel: function () {
                        // add cancel code..
                    },
                    buttonClicked: function (index) {
                        if (index == 0) {
                            $scope.takePicture(1);
                        }
                        else if (index == 1) {
                            $scope.takePicture(2);
                        }
                        return true;
                    }
                });
            };

            $scope.change_gender = function () {
                var temp = $scope.customer.gender == 1 ? 0 : 1;

                $scope.changing = true;
                FCustomer.change_gender(temp)
                        .success(function (response) {
                            if (response.success) {
                                $scope.customer.gender = temp;
                                FCustomer.saveCustomer($scope.customer);
                            }

                            $scope.changing = false;
                        });
            };

            $scope.update_profile = function () {

                Loading.show($translate.instant('updating_profile'));

                FCustomer.save_profile($scope.customer)
                        .success(function (response) {

                            Loading.hide();

                            if (response.success) {
                                setTimeout(function () {
                                    var elem = document.getElementById('user_name');

                                    if (typeof elem != 'undefined' && elem != null) {
                                        elem.innerHTML = $scope.customer.firstname + ' ' + $scope.customer.lastname;
                                    }
                                }, 2000);

                                FCustomer.saveCustomer($scope.customer);
                                Message.show($translate.instant('profile_updated'));
                            }
                            else {
                                Message.show(response.error);
                            }
                        });
            };

            $scope.refresh_customer = function () {
                FCustomer.get_info()
                        .success(function (response) {
                            $scope.$broadcast('scroll.refreshComplete');
                            if (response.customer) {
                                $scope.customer = response.customer;
                                FCustomer.saveCustomer($scope.customer);
                            }
                        })
                        .error(function () {
                            $scope.$broadcast('scroll.refreshComplete');
                        });
            };

            try
            {
                ga_storage._trackPageview('account.html', 'Account');
            }
            catch (e)
            {
                console.log(e.message);
            }
        })

        .controller('HistoryCtrl', function ($scope, $state, $translate, $ionicScrollDelegate, FCustomer, Message, $timeout, $ionicPopup, IonicClosePopupService) {

            $scope.active_segment = 1;
            $scope.notification = {};
            $scope.more_data = true;
            $scope.more_data_notif = true;
            $scope.orders = [];
            $scope.notifications = [];

            try
            {
                ga_storage._trackPageview('history.html', 'History');
            }
            catch (e)
            {
                console.log(e.message);
            }

            $scope.activate_segment = function (index, name) {
                $scope.active_segment = index;
                $scope.active_segment_name = $translate.instant(name);

                $ionicScrollDelegate.resize();
            };

            $scope.go_place_order = function () {
                $state.go('app.map');
            };

            $scope.go_view_order = function (id_order) {
                $state.go('app.view_order', {id_order: id_order});
            };

            $scope.load_orders = function () {
                var count = typeof $scope.orders != 'undefined' ? $scope.orders.length : 0;

                FCustomer.get_orders(count).success(function (response) {
                    if (response.success) {
                        var temp = $scope.orders.concat(response.orders);
                        $scope.orders = temp;

                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.$broadcast('scroll.resize');

                        if (response.orders.length <= 0) {
                            $scope.more_data = false;
                        }
                    }
                    else {
                        $scope.more_data = false;
                    }
                }).error(function () {
                });
            };

            $scope.load_notifications = function () {
                var count = typeof $scope.notifications != 'undefined' ? $scope.notifications.length : 0;

                FCustomer.get_notifications(count).success(function (response) {
                    if (response.success) {
                        var temp = $scope.notifications.concat(response.notifications);
                        $scope.notifications = temp;

                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.$broadcast('scroll.resize');

                        if (response.notifications.length <= 0) {
                            $scope.more_data_notif = false;
                        }
                    }
                    else {
                        $scope.more_data_notif = false;
                    }
                }).error(function () {
                });
            };

            $scope.reload_notifications = function () {
                $scope.load_notifications();
            };

            var notificationPopup;
            $scope.show_notification = function () {

                // Add animate css class to out popup container
                $timeout(function () {
                    var popupElements = document.getElementsByClassName("popup-container");
                    if (popupElements.length) {
                        $scope.popupElement = angular.element(popupElements[0]);
                        $scope.popupElement.addClass('animated');
                        $scope.popupElement.addClass('bounceInDown');
                    }
                }, 1);

                notificationPopup = $ionicPopup.show({
                    templateUrl: 'templates/notification.html',
                    title: $translate.instant('notification'),
                    scope: $scope
                });
                IonicClosePopupService.register(notificationPopup);
            };

            $scope.close_notification = function () {
                notificationPopup.close();
            };

            $scope.view_notification = function (notification) {
                if (notification.modal == 1) {
                    if (!notification.opened_at) {
                        FCustomer.set_notification(notification.id_notification)
                                .success(function (response) {
                                    if (response.success) {
                                        notification.opened_at = 1;
                                        $scope.notification = notification;
                                        $scope.show_notification();
                                    }
                                });
                    }
                    else {
                        $scope.notification = notification;
                        $scope.show_notification();
                    }
                }
                else {
                    if (!notification.opened_at) {
                        FCustomer.set_notification(notification.id_notification)
                                .success(function (response) {
                                    if (response.success) {
                                        notification.opened_at = 1;
                                        Message.show(notification.message);
                                    }
                                });
                    }
                    else {
                        Message.show(notification.message);
                    }
                }
            };
        })

        .controller('OrderCtrl', function ($scope, $state, Message, $stateParams, FCustomer, $ionicModal, $translate, $ionicActionSheet, FOrder, Loading, Session) {

            var id_order = $stateParams.id_order;
            $scope.view_ready = false;
            $scope.loading = false;
            $scope.default_img = 'img/default.jpg';
            $scope.default_user = 'img/default_user.png';

            try
            {
                ga_storage._trackPageview('view_order.html', 'View Order');
            }
            catch (e)
            {
                console.log(e.message);
            }

            $scope.go_place_order = function () {
                $state.go('app.map');
            };

            $scope.load_order = function () {
                $scope.loading = true;
                FCustomer.get_order(id_order)
                        .success(function (response) {
                            if (response.success) {
                                $scope.order = response.order;
                                $scope.coupon = response.coupon;
                                $scope.garments = response.order.garments;
                                $scope.view_ready = true;
                                $scope.copy = response.order;
                                $scope.express_amount = response.express_amount;
                            }

                            $scope.$broadcast('scroll.refreshComplete');

                            $scope.loading = false;
                        })
                        .error(function () {
                            $scope.loading = false;
                        });
            };

            $scope.load_order();

            $ionicModal.fromTemplateUrl('templates/rate_order.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.modalAddress = modal;
            });

            // Triggered in the login modal to close it
            $scope.close_rate = function () {
                $scope.modalAddress.hide();
            };

            // Open the login modal
            $scope.show_rate = function () {
                $scope.modalAddress.show();
                $scope.expandText();
            };

            $scope.rate = function (stars) {
                $scope.order.rating = stars;
            };

            $scope.save_rating = function () {

                var rating = {
                    stars: $scope.order.rating,
                    review: $scope.order.review
                };

                FCustomer.save_rating(id_order, rating)
                        .success(function (response) {
                            if (response.success) {
                                Message.show($translate.instant('thanks_feedback'));
                                $scope.close_rate();

                                try
                                {
                                    ga_storage._trackPageview('save_rating.html', 'Save Rating');
                                }
                                catch (e)
                                {
                                    console.log(e.message);
                                }
                            }
                            else {
                                Message.show(response.error);
                            }
                        });
            };

            $scope.cancel_order = function () {

                var title = $translate.instant('cancel_order');
                var message = $translate.instant('sure_cancel_order');

                Message.confirm(title, message).then(function (res) {
                    if (res === true || res == 2) {
                        Loading.show($translate.instant('loading'));
                        FCustomer.cancel_order(id_order)
                                .success(function (response) {
                                    Loading.hide();
                                    if (response.success) {
                                        Message.show($translate.instant('order_cancelled'));
                                        $state.go('app.history');
                                    }
                                    else {
                                        Message.show(response.error);
                                    }
                                })
                                .error(function () {
                                    Loading.hide();
                                    Message.show($translate.instant('an_error'));
                                });
                    }
                });
            };

            $scope.prepare_edit = function (replicate) {

                Loading.show($translate.instant('loading'));

                FCustomer.load_order_edit(id_order)
                        .success(function (response) {
                            Loading.hide();
                            if (response.success) {
                                if (replicate == 1) {
                                    Session.unset('editing_order');
                                    try
                                    {
                                        ga_storage._trackPageview('replicate.html', 'Replicating');
                                    }
                                    catch (e)
                                    {
                                        console.log(e.message);
                                    }
                                }
                                else {
                                    Session.set('editing_order', id_order);
                                    try
                                    {
                                        ga_storage._trackPageview('editing.html', 'Editing');
                                    }
                                    catch (e)
                                    {
                                        console.log(e.message);
                                    }
                                }

                                Session.set('formatted_address', angular.toJson(response.formatted));
                                Session.set('id_address', response.id_address);
                                Session.set('loaded_details', angular.toJson(response.address_details));

                                if (response.go_schedule) {
                                    Session.set('provider', angular.toJson(response.provider));
                                    Session.set('from_map', 1);
                                }
                                else {
                                    Session.set('providers', angular.toJson(response.providers));
                                }

                                var cart = FOrder.resetCart();
                                cart.garments = $scope.order.total_items > 0 || $scope.order.total_kg > 0 ? FOrder.syncCart($scope.order.garments) : {};
                                cart.total_items = $scope.order.total_items;
                                cart.total_kg = $scope.order.total_kg;
                                cart.total_amount = parseFloat($scope.order.subtotal);
                                FOrder.saveCart(cart);

                                $scope.order.garments = null;
                                $scope.order.coupon_code = $scope.order.voucher_code;
                                $scope.order.coupon_discount = $scope.coupon.discount;
                                $scope.order.coupon_condition = $scope.coupon.condition;
                                $scope.order.address_details = response.address_details;
                                $scope.order.instructions = {
                                    keep_config: 1,
                                    folded: $scope.order.inst_folded,
                                    at_my_door: $scope.order.inst_at_door,
                                    call_pickup: $scope.order.inst_call_pickup,
                                    call_delivery: $scope.order.inst_call_delivery,
                                    message: $scope.order.inst_message
                                };

                                FOrder.saveOrder($scope.order);

                                if (response.go_schedule) {
                                    $state.go('app.schedule');
                                }
                                else {
                                    $state.go('app.provider_details', {id_provider: response.id_provider});
                                }
                            }
                            else {
                                Message.show(response.error);
                            }
                        })
                        .error(function () {
                            Loading.hide();
                        });
            };

            $scope.show_options = function () {

                var buttons = [];

                if ($scope.order.id_status == 1) {
                    var buttons = [
                        {text: $translate.instant('edit_order')}
                    ];

                    buttons.push({
                        text: $translate.instant('cancel_order')
                    });
                }
                else {
                    var buttons = [
                        {text: $translate.instant('replicate_order')}
                    ];
                }

                // Show the action sheet
                $ionicActionSheet.show({
                    buttons: buttons,
                    titleText: $translate.instant('order_options'),
                    cancelText: $translate.instant('cancel'),
                    cancel: function () {
                        // add cancel code..
                    },
                    buttonClicked: function (index) {
                        if (index == 0) {
                            if ($scope.order.id_status == 1) {
                                $scope.prepare_edit();
                            }
                            else {
                                $scope.prepare_edit(1);
                            }
                        }
                        else if (index == 1 && $scope.order.id_status == 1) {
                            $scope.cancel_order();
                        }

                        return true;
                    }
                });
            };

            $scope.expandText = function () {
                var element = document.getElementById("message");
                element.style.height = element.scrollHeight + "px";
            };
        })

        .controller('CardsCtrl', function ($scope, $state, $translate, FCustomer, Message, Loading) {

            $scope.cards = [];
            $scope.view_ready = false;

            $scope.load_cards = function () {
                $scope.loading_cards = true;

                FCustomer.get_cards()
                        .success(function (response) {
                            if (response.success) {
                                $scope.cards = response.customer_cards;
                            }
                            else {
                            }

                            $scope.view_ready = true;
                            $scope.loading_cards = false;
                            $scope.$broadcast('scroll.refreshComplete');
                        })
                        .error(function () {
                            $scope.view_ready = true;
                            $scope.loading_cards = false;
                            $scope.$broadcast('scroll.refreshComplete');
                        });

            };

            $scope.load_cards();

            $scope.go_add_payment = function () {
                $state.go('app.add_payment');
            };

            $scope.delete_card = function (id_card) {

                var title = 'Remove Credit Card';
                var message = 'Are you sure you want to remove this credit card?';

                Message.confirm(title, message).then(function (res) {
                    if (res === true || res == 2) {
                        Loading.show($translate.instant('loading'));
                        FCustomer.delete_card(id_card)
                                .success(function (response) {
                                    if (response.success) {
                                        $scope.cards = response.customer_cards;
                                    }
                                    else {
                                        Message.show(response.error);
                                    }
                                })
                                .finally(function () {
                                    Loading.hide();
                                });
                    }
                });

            };

            try
            {
                ga_storage._trackPageview('cards.html', 'Cards');
            }
            catch (e)
            {
                console.log(e.message);
            }

        })

        .controller('AddPaymentCtrl', function ($scope, $state, Loading, $translate, Message, FConnection, FCustomer, Session, $timeout) {

            if (FConnection.isOffline()) {
                $state.go('app.internet_error');
                return false;
            }

            $scope.customer_card = {};

            $scope.checkout_events = function () {
                $scope.reset_form = function () {
                    document.getElementById('submit_card').removeAttribute('disabled');
                    $scope.customer_card = {};
                    $scope.month_year = '';
                };

                CheckoutKit.removeAllEventHandlers(CheckoutKit.Events.API_ERROR);
                CheckoutKit.removeAllEventHandlers(CheckoutKit.Events.CARD_TOKENISED);

                CheckoutKit.addEventHandler(CheckoutKit.Events.API_ERROR, function (event) {
                    Loading.hide();
                    Message.show(event.data.message);
                    document.getElementById('btn_payment').removeAttribute('disabled');
                    $scope.reset_form();
                });

                CheckoutKit.addEventHandler(CheckoutKit.Events.CARD_TOKENISED, function (event) {
                    $scope.customer_card = event.data;

                    FCustomer.add_card($scope.customer_card)
                            .success(function (response) {
                                if (response.success) {
                                    $scope.input_card = false;

                                    if (Session.get('after_add_card') == 'checkout') {
                                        $state.go('app.checkout');
                                    }
                                    else {
                                        $state.go('app.cards');
                                    }
                                    Session.unset('after_add_card');
                                }
                                else {
                                    Message.show(response.error);
                                }

                                Loading.hide();
                                $scope.reset_form();
                            })
                            .error(function () {
                                Loading.hide();
                                $scope.reset_form();
                            });
                });

                CheckoutKit.monitorForm('#form-register-card', CheckoutKit.CardFormModes.CARD_TOKENISATION);
            };

            // Initializate Checkout Payment
            if (typeof CheckoutKit != 'undefined') {
                $scope.checkout_events();
            }
            else {
                FConnection.reload_modules(1);

                setTimeout(function () {
                    $scope.checkout_events();
                }, 1000);
            }

            $scope.is_invalid_form = function () {
                var invalid = !$scope.customer_card.number || !$scope.customer_card.exp_month || !$scope.customer_card.exp_year || !$scope.customer_card.cvv;
                return invalid;
            };

            $scope.add_payment = function () {
                Loading.show($translate.instant('loading'));
                $timeout(function () {
                    document.getElementById('submit_card').click();
                });
            };

            $scope.go_back = function () {
                if (Session.get('after_add_card') == 'checkout') {
                    $state.go('app.checkout');
                }
                else {
                    $state.go('app.cards');
                }
                Session.unset('after_add_card');
            };

            $scope.load_cardio = function () {

                var onCardIOComplete = function (response) {
                    if (typeof response != 'undefined' && response != null) {
                        $timeout(function () {
                            $scope.customer_card.number = response['redacted_card_number'];
                            $scope.customer_card.card_number = response['card_number'];
                            $scope.customer_card.exp_month = response['expiry_month'];
                            $scope.customer_card.exp_year = response['expiry_year'];
                            $scope.customer_card.cvv = response['cvv'];
                            $scope.month_year = response['expiry_month'] + ' / ' + response['expiry_year'];
                        }, 0);
                    }
                };

                var onCardIOCancel = function () {
                    console.log("card.io scan cancelled");
                };

                var onCardIOCheck = function (canScan) {
                    $scope.open_card = function (e) {
                        CardIO.scan({
                            "expiry": true,
                            "cvv": true,
                            "zip": false,
                            "suppressManual": false,
                            "suppressConfirm": false,
                            "hideLogo": true
                        },
                                onCardIOComplete, onCardIOCancel);
                    };
                };

                CardIO.canScan(onCardIOCheck);
            };

            $scope.load_cardio();

            try
            {
                ga_storage._trackPageview('add_payment.html', 'Add Payment');
            }
            catch (e)
            {
                console.log(e.message);
            }
        })

        .controller('AddressesCtrl', function ($scope, $state, $translate, Session, FCustomer, Loading, Message) {

            $scope.addresses = [];
            $scope.view_ready = false;

            $scope.go_add_address = function () {
                Session.set('previous_view', 'account');
                $state.go('app.map');
            };

            $scope.load_addresses = function () {
                FCustomer.get_addresses()
                        .success(function (response) {
                            if (response.success) {
                                $scope.addresses = response.addresses;
                            }
                            else {
                            }
                        })
                        .finally(function () {
                            $scope.view_ready = true;
                            $scope.$broadcast('scroll.refreshComplete');
                        });
            };

            $scope.load_addresses();

            $scope.delete = function (address) {
                var title = $translate.instant('delete_ddress');
                var message = $translate.instant('sure_delete_address');

                Message.confirm(title, message).then(function (res) {
                    if (res === true || res == 2) {
                        Loading.show($translate.instant('loading'));

                        FCustomer.delete_address(address.id_address)
                                .success(function (response) {
                                    if (response.success) {
                                        $scope.load_addresses();
                                    }
                                    else {
                                        Message.show(response.error);
                                    }
                                })
                                .finally(function () {
                                    Loading.hide();
                                    $scope.$broadcast('scroll.refreshComplete');
                                });
                    }
                });
            };

            try
            {
                ga_storage._trackPageview('addresses.html', 'Addresses');
            }
            catch (e)
            {
                console.log(e.message);
            }

        })

        .controller('PreferencesCtrl', function ($scope, $translate, Loading, Message, FCustomer, Push, Language, Session) {

            $scope.languages = [];

            $scope.data = {
                active_language: 0
            };

            $scope.customer = FCustomer.getCustomer();

            FCustomer.get_languages()
                    .success(function (response) {
                        if (response.success) {
                            $scope.languages = response.languages;
                        }
                    });

            $scope.save_preferences = function () {

                Loading.show($translate.instant('updating_preferences'));

                FCustomer.save_preferences($scope.customer)
                        .success(function (response) {

                            Loading.hide();

                            if (response.success) {
                                FCustomer.saveCustomer(response.customer);

                                if ($scope.customer.pref_notifications != 1) {
                                    //Push.remove();
                                }
                                else {
                                    Push.register();
                                }

                                Session.set('language', response.customer.language);
                                Language.setLanguage(response.customer.language);

                                Message.show($translate.instant('preferences_updated'));
                            }
                            else {
                                Message.show(response.error);
                            }
                        });
            };

            $scope.remove_notification = function () {
                if (!$scope.customer.pref_notifications) {
                    var title = $translate.instant('remove_notifications');
                    var message = $translate.instant('notification_alert');

                    Message.confirm(title, message).then(function (res) {
                        if (res === true || res == 2) {
                        }
                        else {
                            $scope.customer.pref_notifications = true;
                        }
                    });
                }
            };

            try
            {
                ga_storage._trackPageview('preferences.html', 'Preferences');
            }
            catch (e)
            {
                console.log(e.message);
            }

        })

        .controller('FreeLaundryCtrl', function ($scope, FCustomer, Message, $cordovaFacebook, $cordovaSocialSharing, $translate) {

            $scope.loading = false;
            $scope.customer = FCustomer.getCustomer();

            $scope.give = 0;
            $scope.get = 0;
            $scope.message = '';

            $scope.check_credit = function () {
                $scope.loading = true;

                FCustomer.check_credit()
                        .success(function (response) {
                            if (response.success) {
                                $scope.give = response.give;
                                $scope.get = response.get;
                                $scope.link = response.link;
                                $scope.customer.credit = response.credit;
                                $scope.currency = response.currency;

                                $scope.message = $translate.instant('use_code') + " " + $scope.customer.promo_code + ' at ' + $scope.link + ' and get ' + $scope.get + ' ' + $scope.currency + ' off your first order.';
                                FCustomer.saveCustomer($scope.customer);

                                try
                                {
                                    ga_storage._trackPageview('check_credit.html', 'Check Credit');
                                }
                                catch (e)
                                {
                                    console.log(e.message);
                                }
                            }
                            else {
                                Message.show(response.error);
                            }

                            $scope.loading = false;
                        });
            };
            $scope.check_credit();

            $scope.fb_share = function () {

                $cordovaFacebook.getLoginStatus()
                        .then(function (success) {
                            if (success.status === 'connected') {
                                var options = {
                                    method: "feed",
                                    link: $scope.link,
                                    caption: $translate.instant('share_code') + " " + $scope.customer.promo_code + " " + $translate.instant('with_friends')
                                };
                                $cordovaFacebook.showDialog(options)
                                        .then(function (success) {

                                            try
                                            {
                                                ga_storage._trackPageview('share_facebook.html', 'Share Facebook');
                                            }
                                            catch (e)
                                            {
                                                console.log(e.message);
                                            }

                                            //Message.show('Thanks for sharing');
                                        }, function (error) {
                                            // error
                                        });
                            }
                            else {
                                $cordovaFacebook.login(["public_profile", "email", "user_friends"])
                                        .then(function (success) {

                                            var options = {
                                                method: "feed",
                                                link: $scope.link,
                                                caption: $translate.instant('share_code') + " " + $scope.customer.promo_code + " " + $translate.instant('with_friends')
                                            };
                                            $cordovaFacebook.showDialog(options)
                                                    .then(function (success) {
                                                        //alert(success);
                                                    }, function (error) {
                                                        // error
                                                    });
                                        }, function (error) {
                                            //alert('error');
                                        });
                            }
                        }, function (error) {
                            //alert('error');
                        });
            };

            $scope.email_share = function () {
                $cordovaSocialSharing.shareViaEmail($scope.message, '').then(function (result) {
                    try
                    {
                        ga_storage._trackPageview('share_email.html', 'Share Email');
                    }
                    catch (e)
                    {
                        console.log(e.message);
                    }
                }, function (err) {
                    Message.show($translate.instant('an_error'));
                });
            };

            $scope.sms_share = function () {
                $cordovaSocialSharing.shareViaSMS($scope.message, '').then(function (result) {
                    try
                    {
                        ga_storage._trackPageview('share_sms.html', 'Share SMS');
                    }
                    catch (e)
                    {
                        console.log(e.message);
                    }
                }, function (err) {
                    Message.show($translate.instant('went_wrong'));
                });
            };

            try
            {
                ga_storage._trackPageview('free_laundry.html', 'Business');
            }
            catch (e)
            {
                console.log(e.message);
            }

        });