angular.module('getlaundry.common_directives', [])

        .factory('MyHttpIntercept', function ($q, $injector) {

            return {
                'response': function (response) {

                    var last_seg = response.config.url.split('/');
                    last_seg = last_seg[last_seg.length - 1];

                    if (typeof response.data != 'undefined' && response.data)
                    {
                        if (typeof response.data.error != 'undefined')
                        {
                            var Auth = $injector.get('Auth');
                            var State = $injector.get('$state');
                            var Msg = $injector.get('Message');
                            //var Session = $injector.get('Session');

                            if (response.data.error == "100")
                            {
                                Auth.logout();
                                State.go('app.map');

                                if (response.data.message && response.data.message != '')
                                {
                                    Msg.show(response.data.message);
                                }
                            }
                        }
                    }

                    return response;
                }
            };
        })

        .directive('onErrorSrc', function () {
            return {
                link: function (scope, element, attrs) {
                    element.bind('error', function () {
                        if (attrs.src != attrs.onErrorSrc) {
                            attrs.$set('src', attrs.onErrorSrc);
                        }
                    });
                }
            };
        })

        .service('IonicClosePopupService', [
            function () {
                var currentPopup;
                var htmlEl = angular.element(document.querySelector('html'));
                htmlEl.on('click', function (event) {
                    if (event.target.nodeName === 'HTML') {
                        if (currentPopup) {
                            currentPopup.close();
                        }
                    }
                });

                this.register = function (popup) {
                    currentPopup = popup;
                };
            }
        ]);
        