angular.module('getlaundry.customer_services', [])

        .factory('FCustomer', function ($http, Session, API_URL) {
            return {
                login: function (login_data) {
                    return $http.post(API_URL + 'login', {
                        api_signature: Session.get('api_signature'),
                        login_data: login_data
                    });
                },
                login_branch: function (api_signature) {
                    return $http.post(API_URL + 'login_branch', {
                        api_signature: api_signature
                    });
                },
                create_fb_token: function () {
                    return $http.post(API_URL + 'create_fb_token', {
                        api_signature: Session.get('api_signature')
                    });
                },
                check_fb_token: function (data) {
                    return $http.post(API_URL + 'check_fb_token', {
                        api_signature: Session.get('api_signature'),
                        data: data
                    });
                },
                signup: function (signup_data) {
                    return $http.post(API_URL + 'signup', {
                        signup_data: signup_data,
                        language: Session.get('language')
                    });
                },
                recover: function (email) {
                    return $http.post(API_URL + 'recover', {
                        api_signature: Session.get('api_signature'),
                        email: email
                    });
                },
                save_profile: function (customer) {
                    return $http.post(API_URL + 'save_profile', {
                        api_signature: Session.get('api_signature'),
                        customer: customer
                    });
                },
                save_preferences: function (customer) {
                    return $http.post(API_URL + 'save_preferences', {
                        api_signature: Session.get('api_signature'),
                        customer: customer
                    });
                },
                change_password: function (new_password) {
                    return $http.post(API_URL + 'change_password', {
                        api_signature: Session.get('api_signature'),
                        new_password: new_password
                    });
                },
                change_contact: function (new_contact, verification) {
                    return $http.post(API_URL + 'change_contact', {
                        api_signature: Session.get('api_signature'),
                        new_contact: new_contact,
                        verification: verification
                    });
                },
                resend_verification: function (contact) {
                    return $http.post(API_URL + 'resend_verification', {
                        api_signature: Session.get('api_signature'),
                        contact: contact
                    });
                },
                get_addresses: function (limit) {
                    return $http.post(API_URL + 'get_addresses', {
                        api_signature: Session.get('api_signature'),
                        limit: limit
                    });
                },
                add_address: function (location) {
                    return $http.post(API_URL + 'add_customer_address', {
                        api_signature: Session.get('api_signature'),
                        location: location
                    });
                },
                update_address: function (address) {
                    return $http.post(API_URL + 'update_customer_address', {
                        api_signature: Session.get('api_signature'),
                        address: address
                    });
                },
                delete_address: function (id_address) {
                    return $http.post(API_URL + 'delete_customer_address', {
                        api_signature: Session.get('api_signature'),
                        id_address: id_address
                    });
                },
                saveCustomer: function (customer) {
                    Session.set('customer', angular.toJson(customer));
                    Session.set('api_signature', customer.api_signature);
                },
                getCustomer: function () {
                    return angular.fromJson(Session.get('customer'));
                },
                get_info: function () {
                    return $http.post(API_URL + 'get_customer_info', {
                        api_signature: Session.get('api_signature')
                    });
                },
                get_languages: function () {
                    return $http.post(API_URL + 'get_languages', {
                        api_signature: Session.get('api_signature')
                    });
                },
                get_preferences: function () {
                    return $http.post(API_URL + 'get_customer_preferences', {
                        api_signature: Session.get('api_signature')
                    });
                },
                get_cards: function () {
                    return $http.post(API_URL + 'get_cards', {
                        api_signature: Session.get('api_signature')
                    });
                },
                change_gender: function (gender) {
                    return $http.post(API_URL + 'change_gender', {
                        api_signature: Session.get('api_signature'),
                        gender: gender
                    });
                },
                check_credit: function () {
                    return $http.post(API_URL + 'check_credit', {
                        api_signature: Session.get('api_signature')
                    });
                },
                load_config: function () {
                    return $http.post(API_URL + 'load_config', {
                        api_signature: Session.get('api_signature')
                    });
                },
                delete_card: function (id_card) {
                    return $http.post(API_URL + 'delete_customer_card', {
                        api_signature: Session.get('api_signature'),
                        id_card: id_card
                    });
                },
                add_card: function (card) {
                    return $http.post(API_URL + 'add_customer_card', {
                        api_signature: Session.get('api_signature'),
                        card: card
                    });
                },
                get_notifications: function (offset) {
                    return $http.post(API_URL + 'get_customer_notifications', {
                        api_signature: Session.get('api_signature'),
                        offset: offset
                    });
                },
                get_orders: function (offset) {
                    return $http.post(API_URL + 'get_customer_orders', {
                        api_signature: Session.get('api_signature'),
                        offset: offset
                    });
                },
                get_order: function (id_order) {
                    return $http.post(API_URL + 'get_customer_order', {
                        api_signature: Session.get('api_signature'),
                        id_order: id_order
                    });
                },
                load_order_edit: function (id_order) {
                    return $http.post(API_URL + 'get_customer_order_edit', {
                        api_signature: Session.get('api_signature'),
                        id_order: id_order
                    });
                },
                cancel_order: function (id_order) {
                    return $http.post(API_URL + 'cancel_order', {
                        api_signature: Session.get('api_signature'),
                        id_order: id_order
                    });
                },
                save_rating: function (id_order, rating) {
                    return $http.post(API_URL + 'save_rating', {
                        api_signature: Session.get('api_signature'),
                        id_order: id_order,
                        rating: rating
                    });
                },
                set_notification: function (id_notification) {
                    return $http.post(API_URL + 'set_notification', {
                        api_signature: Session.get('api_signature'),
                        id_notification: id_notification
                    });
                },
                get_support: function () {
                    return $http.post(API_URL + 'get_support', {
                        api_signature: Session.get('api_signature')
                    });
                },
                get_country_areas: function (country_code) {
                    return $http.post(API_URL + 'get_country_areas', {
                        api_signature: Session.get('api_signature'),
                        country_code: country_code
                    });
                }
            };
        });