angular.module('getlaundry.order_services', [])

        .factory('FOrder', function ($http, Session, API_URL) {
            return {
                get_providers_by_location: function (location) {
                    return $http.post(API_URL + 'get_providers_by_location', {
                        api_signature: Session.get('api_signature'),
                        location: location
                    });
                },
                check_provider_location: function (id_provider, location) {
                    return $http.post(API_URL + 'check_provider_location', {
                        api_signature: Session.get('api_signature'),
                        id_provider: id_provider,
                        location: location
                    });
                },
                submit_request: function (request, email) {
                    return $http.post(API_URL + 'submit_request', {
                        api_signature: Session.get('api_signature'),
                        request: request,
                        email: email,
                    });
                },
                getCart: function () {
                    var cart = angular.fromJson(Session.get('cart'));
                    if (typeof cart != 'undefined' && cart != null) {
                        return cart;
                    }

                    return this.resetCart();
                },
                saveCart: function (cart) {
                    Session.set('cart', angular.toJson(cart));
                },
                resetCart: function () {
                    var cart = {
                        garments: {},
                        service: 1,
                        total_items: 0,
                        total_kg: 0,
                        total_amount: 0
                    };
                    this.saveCart(cart);
                    return cart;
                },
                syncCart: function (garments) {
                    var cart = this.getCart();
                    angular.forEach(garments, function (garment, key) {
                        angular.forEach(cart.garments, function (value, key2) {
                            if (garment.id_garment_has_service == value.id_garment_has_service) {
                                garments[key] = value;
                            }
                        });
                    });
                    return garments;
                },
                get_provider: function (id_provider) {
                    return $http.post(API_URL + 'get_provider', {
                        api_signature: Session.get('api_signature'),
                        id_provider: id_provider
                    });
                },
                getProvider: function () {
                    return angular.fromJson(Session.get('provider'));
                },
                getProviders: function () {
                    return angular.fromJson(Session.get('providers'));
                },
                saveProvider: function (provider) {
                    Session.set('provider', angular.toJson(provider));
                },
                deleteProvider: function () {
                    Session.unset('provider');
                },
                deleteProviders: function () {
                    Session.unset('providers');
                },
                resetOrder: function () {
                    var order = {
                        cart: '',
                        id_provider: '',
                        id_address: '',
                        formatted_address: '',
                        address_details: {
                            name: '',
                            building: '',
                            unit: '',
                            street: '',
                            indications: ''
                        },
                        pickup_date: '',
                        pickup_time: '',
                        delivery_date: '',
                        delivery_time: '',
                        coupon_code: '',
                        coupon_discount: '',
                        coupon_condition: 0,
                        coupon_discounted: 0,
                        subtotal: 0,
                        is_express: 0,
                        express_fee: 0,
                        delivery_fee: 0,
                        credit: 0,
                        total_amount: 0,
                        save_card: true,
                        payment_method: 'online',
                        instructions: {
                            keep_config: true,
                            folded: 0,
                            at_my_door: 0,
                            call_pickup: 0,
                            call_delivery: 0,
                            message: ''
                        }
                    };
                    this.saveOrder(order);
                    return order;
                },
                getOrder: function () {
                    return angular.fromJson(Session.get('order'));
                },
                saveOrder: function (order) {
                    Session.set('order', angular.toJson(order));
                },
                deleteOrder: function () {
                    Session.unset('order');
                },
                get_provider_schedule: function (id_provider, pickup_info) {
                    return $http.post(API_URL + 'get_provider_schedule', {
                        api_signature: Session.get('api_signature'),
                        id_provider: id_provider,
                        pickup_info: pickup_info
                    });
                },
                getAddress: function () {
                    return Session.get('formatted_address');
                },
                place_order: function (order) {
                    return $http.post(API_URL + 'place_order', {
                        api_signature: Session.get('api_signature'),
                        order: order,
                        editing_order: Session.get('editing_order')
                    });
                },
                check_coupon: function (coupon_code) {
                    return $http.post(API_URL + 'check_coupon', {
                        api_signature: Session.get('api_signature'),
                        coupon_code: coupon_code,
                        editing_order: Session.get('editing_order')
                    });
                },
                get_offers: function (location) {
                    return $http.post(API_URL + 'get_offers', {
                        api_signature: Session.get('api_signature'),
                        location: location
                    });
                }
            };
        });